// BSch.cpp : AvP[VpNX̋@\`s܂B
//

#include "stdafx.h"
#include "cderr.h"
#include "BSch.h"

#include "Client.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "BSchObj.h"

#include "BSchDoc.h"
#include "BSchView.h"

#include "PartLib.h"
#include "BSchFont.h"
#include "Global.h"
#include "Splash.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CBSchApp

BEGIN_MESSAGE_MAP(CBSchApp, CWinApp)
	//{{AFX_MSG_MAP(CBSchApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_PRINT_SETUP, OnFilePrintSetup)
	//}}AFX_MSG_MAP
	// W̃t@C{hLg R}h
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// ẄZbgAbv R}h
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBSchApp NX̍\z

CBSchApp::CBSchApp()
{
	// TODO: ̈ʒuɍ\zpR[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
	int i;
	for(i=0;i<MAX_LIB;i++) g_pPartLib[i]=NULL;
	g_bPrintPartNum  = TRUE;	// 1997/01/26
	g_bPrintPartName = TRUE;	// 1998/07/22
	g_bUsePreview    = TRUE;	// 1998/11/09
	g_bSnaptoGrid	 = TRUE;	// 1998/11/09
	// Version 0.40 1998/05/19
	// JgfBNgINIt@Cg悤ɕύX
	m_pszIniFileName = new char[_MAX_PATH];				//pXi[GÅm
					//MFCdeletêŁAŒGAmۂĂ͂ȂB
	::GetCurrentDirectory(_MAX_PATH,m_pszIniFileName);	//JgfBNg𓾂
	lstrcat(m_pszIniFileName,"\\BSCH.INI");			//\\BSCH.INIǉ
	//lstrcpy(m_pszIniFileName,"BSCH.INI");
	FILE *pf=fopen(m_pszIniFileName,"rt");
	if(pf){
		fclose(pf);
		m_pszProfileName=m_pszIniFileName;	//쐬̃|C^m_pszProfileNameɃRs[
	}else{
		//JgfBNgINIt@Cꍇ́Ast@C
		//fBNgBSCH.INIgp 2000/05/08 Version 0.82a
		char drive[_MAX_DRIVE];
		char dir[_MAX_DIR];
		::GetModuleFileName(NULL,m_pszIniFileName,_MAX_PATH);
		::_splitpath(m_pszIniFileName,drive,dir,NULL,NULL);
		::_makepath(m_pszIniFileName,drive,dir,"BSCH",".INI");
	}
	m_pszProfileName=m_pszIniFileName;	//쐬̃|C^m_pszProfileNameɃRs[
//	if(!pf){
//		delete[]m_pszIniFileName;
//		m_pszIniFileName = NULL;
//	}else{
//		fclose(pf);
//		m_pszProfileName=m_pszIniFileName;	//쐬̃|C^m_pszProfileNameɃRs[
//	}
	
	//	TRACE("m_pszProfileName %s\n",m_pszProfileName);
}

/////////////////////////////////////////////////////////////////////////////
// CBSchApp NX̏  96/10/20 ǉ

CBSchApp::~CBSchApp()
{
	g_FreeLibrary();	//Cũ
	delete g_pFont;
}



/////////////////////////////////////////////////////////////////////////////
// B CBSchApp IuWFNg

CBSchApp theApp;


/////////////////////////////////////////////////////////////////////////////
// CBSchApp NX̏

BOOL CBSchApp::InitInstance()
{
	BOOL fFileNew=FALSE;

	// CG: ̃ubŃuXvbV XN[vR|[lgɂǉĂ܂B
	{
		CCommandLineInfo cmdInfo;
		ParseCommandLine(cmdInfo);
		fFileNew = (cmdInfo.m_nShellCommand == CCommandLineInfo::FileNew);
		if(!fFileNew)cmdInfo.m_bShowSplash=FALSE;
		CSplashWnd::EnableSplashScreen(cmdInfo.m_bShowSplash);
	}
	// WIȏ
	// ̋@\gpAst@C̃TCY
	// Έȉ̓̏[`̒sKvȂ
	// 폜ĂB

#ifdef _AFXDLL
	Enable3dControls();			// L DLL ̒ MFC gpꍇɂ͂R[ĂB 
#else
	Enable3dControlsStatic();	// MFC ƐÓIɃNĂꍇɂ͂R[ĂB
#endif
//	SetRegistryKey("Suigyodo");	//INIt@C̑ɃWXg"Suigyodo()"g
// 1998/05/19
// Version 0.40   WXĝɃJgfBNg BSCH.INI gp悤ɕύX
// CBSchApp() (RXgN^) ŁAm_pszProfileName ɃJgfBNgBSCH.INIw
// 悤ɐݒ
// TRACE("m_pszProfileName %s\n",m_pszProfileName);
	LoadStdProfileSettings(10);  // W INI t@C̃IvV[ނ܂ (MRU ܂)
	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	// ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B


	/////////////////////////////////////////////////////////////////////////////
	// 96/10/21
	//O[oϐ̏Ȃ
	g_ReadLibrary(!fFileNew);	//iCu̓ǂݍ
	g_pFont=new CBSchFont;
	g_RegisterClipboardFormat();//Nbv{[htH[}bg̓o^

//	CSingleDocTemplate* pDocTemplate;
//	pDocTemplate = new CSingleDocTemplate(
//		IDR_MAINFRAME,
//		RUNTIME_CLASS(CBSchDoc),
//		RUNTIME_CLASS(CMainFrame),       // C SDI t[ EBhE
//		RUNTIME_CLASS(CBSchView));
//	AddDocTemplate(pDocTemplate);

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_BSCHTYPE,
		RUNTIME_CLASS(CBSchDoc),
		RUNTIME_CLASS(CChildFrame), // JX^ MDI qt[
		RUNTIME_CLASS(CBSchView));
	AddDocTemplate(pDocTemplate);

	// C MDI t[ EBhE쐬
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;


	g_bUsePreview=g_IniReadUsePreview();	// 1998/11/09 ivr[̏WXg瓾
	g_bSnaptoGrid=TRUE;

	// DDE Execute open gp\ɂ܂B
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);
	// hbO/hbv I[v܂
	m_pMainWnd->DragAcceptFiles();


	// DDEAfile open ȂǕW̃VF R}h̃R}hC͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);


	// R}hCŃfBXpb` R}hw肵܂B
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;


	// C EBhEꂽ̂ŁA\ƍXVs܂B
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	
	return TRUE;
}


//ׂĂMDIqEChE̕\̍XV
void CBSchApp::UpdateAllMDIChild()
{
	POSITION pos = GetFirstDocTemplatePosition();
	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = (CMultiDocTemplate*)GetNextDocTemplate(pos); 
	//BSch̏ꍇ͂ЂƂ̃hLgev[gȂ炱܂łŗǂ

	pos = pDocTemplate->GetFirstDocPosition();
	while(pos){
		CBSchDoc* pDoc = (CBSchDoc*)pDocTemplate->GetNextDoc(pos);
		pDoc->UpdateAllViews(NULL);
	}
}

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

  	// ClassWizard ͉z֐𐶐I[o[Ch܂B
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// bZ[W nh͂܂B
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// _CAOs邽߂̃AvP[V R}h
void CBSchApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CBSchApp R}h


CDocument* CBSchApp::OpenDocumentFile(LPCTSTR lpszFileName) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	TRACE("OpenDocument(%s)\n",lpszFileName);
	//Ot@Cl[IɎgp Version 0.64 1998/12/14
	char szLongFname[_MAX_PATH];
	char szDrive[_MAX_DRIVE];
	char szDir[_MAX_DIR];
	WIN32_FIND_DATA ffd;
	HANDLE hFindFile = ::FindFirstFile(lpszFileName,&ffd);
	if(hFindFile != INVALID_HANDLE_VALUE){
		::_splitpath(lpszFileName,szDrive,szDir,NULL,NULL);
		::_makepath(szLongFname,szDrive,szDir,"","");
		strcat(szLongFname,ffd.cFileName);
		::FindClose(hFindFile);
	}else{
		strcpy(szLongFname,lpszFileName);
	}
	return CWinApp::OpenDocumentFile(szLongFname);
}


BOOL CBSchApp::PreTranslateMessage(MSG* pMsg)
{
	// CG: ̍śuXvbV XN[vR|[lgɂǉĂ܂B
	CSplashWnd::PreTranslateAppMessage(pMsg);

	return CWinApp::PreTranslateMessage(pMsg);
}




/////////////////////////////////////////////////////////////
// v^ݒ֘A
static const char* lpszPrinterSetupInfo = "PrinterSetupInfo";

void CBSchApp::IniWritePrinterSetup()
{
	if(m_hDevNames != NULL && m_hDevMode != NULL){
		DEVNAMES* lpDevNames = (DEVNAMES*)::GlobalLock(m_hDevNames);
		DEVMODE* lpDevMode = (DEVMODE*)::GlobalLock(m_hDevMode);
		AfxGetApp()->WriteProfileString(lpszPrinterSetupInfo,"Driver",(LPCSTR)lpDevNames+lpDevNames->wDriverOffset);
		AfxGetApp()->WriteProfileString(lpszPrinterSetupInfo,"Device",(LPCSTR)lpDevNames+lpDevNames->wDeviceOffset);
		AfxGetApp()->WriteProfileString(lpszPrinterSetupInfo,"Output",(LPCSTR)lpDevNames+lpDevNames->wOutputOffset);
		AfxGetApp()->WriteProfileInt(lpszPrinterSetupInfo,"Orientation",lpDevMode->dmOrientation);
		AfxGetApp()->WriteProfileInt(lpszPrinterSetupInfo,"PaperSize",lpDevMode->dmPaperSize);
		GlobalUnlock(m_hDevNames);
		GlobalUnlock(m_hDevMode);
	}
}



void CBSchApp::UpdatePrinterSelection(BOOL bForceDefaults)
{
	BOOL fSet1st = (m_hDevNames == NULL);
	CWinApp::UpdatePrinterSelection(bForceDefaults);

	if(fSet1st && !bForceDefaults && m_hDevNames != NULL && m_hDevMode != NULL){
		CString strDriver	= AfxGetApp()->GetProfileString(lpszPrinterSetupInfo,"Driver","");
		CString strDevice	= AfxGetApp()->GetProfileString(lpszPrinterSetupInfo,"Device","");
		CString strOutput	= AfxGetApp()->GetProfileString(lpszPrinterSetupInfo,"Output","");
		int nOrientation	= AfxGetApp()->GetProfileInt(lpszPrinterSetupInfo,"Orientation",0);
		int nPaperSize		= AfxGetApp()->GetProfileInt(lpszPrinterSetupInfo,"PaperSize",0);
		DEVNAMES* lpDevNames = (DEVNAMES*)::GlobalLock(m_hDevNames);
		if(
				strcmp((LPCSTR)lpDevNames+lpDevNames->wDriverOffset,strDriver)==0
			&&	strcmp((LPCSTR)lpDevNames+lpDevNames->wDeviceOffset,strDevice)==0
			&&	strcmp((LPCSTR)lpDevNames+lpDevNames->wOutputOffset,strOutput)==0
			){
			DEVMODE* lpDevMode = (DEVMODE*)::GlobalLock(m_hDevMode);
			if(nOrientation!=0) lpDevMode->dmOrientation = nOrientation;
			if(nPaperSize!=0)	lpDevMode->dmPaperSize   = nPaperSize;
			GlobalUnlock(m_hDevMode);
		}
		GlobalUnlock(m_hDevNames);
	}
}

///////////////////////////
// MFC̃\[XƂɉ
void CBSchApp::OnFilePrintSetup() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CPrintDialog pd(TRUE);
	//	DoPrintDialog(&pd);

	UpdatePrinterSelection(FALSE);

	pd.m_pd.hDevMode = m_hDevMode;
	pd.m_pd.hDevNames = m_hDevNames;
	int nResponse = pd.DoModal();

	// if OK or Cancel is selected we need to update cached devMode/Names
	while (nResponse != IDOK && nResponse != IDCANCEL)
	{
		switch (::CommDlgExtendedError())
		{
		// CommDlg cannot give these errors after NULLing these handles
		case PDERR_PRINTERNOTFOUND:
		case PDERR_DNDMMISMATCH:
		case PDERR_DEFAULTDIFFERENT:
			if (pd.m_pd.hDevNames != NULL)
			{
				ASSERT(m_hDevNames == pd.m_pd.hDevNames);
				g_GlobalFree(pd.m_pd.hDevNames);
				pd.m_pd.hDevNames = NULL;
				m_hDevNames = NULL;
			}

			if (pd.m_pd.hDevMode)
			{
				ASSERT(m_hDevMode == pd.m_pd.hDevMode);
				g_GlobalFree(pd.m_pd.hDevMode);
				pd.m_pd.hDevMode = NULL;
				m_hDevMode = NULL;
			}
			break;

		default:
			return;
		}
		nResponse = pd.DoModal();
	}
	// refresh current CWinApp cache of printer device information
	m_hDevMode = pd.m_pd.hDevMode;
	m_hDevNames = pd.m_pd.hDevNames;
	IniWritePrinterSetup();

}
