// LCoAttb.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "LCo.h"
#include "PartInfo.h"
#include "PtnView.h"
#include "LCoAttb.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLCoAttb _CAO


CLCoAttb::CLCoAttb(CWnd* pParent /*=NULL*/)
	: CDialog(CLCoAttb::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLCoAttb)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
	m_nX=m_nY=2;
	m_nBlock=1;
	m_pPtn=NULL;
	m_pListPtn=NULL;
	m_sizeClient=CSize(0,0);
}


void CLCoAttb::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLCoAttb)
                //  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLCoAttb, CDialog)
	//{{AFX_MSG_MAP(CLCoAttb)
	ON_BN_CLICKED(IDC_CHECK_USEPTN, OnCheckUseptn)
	ON_WM_SIZE()
	ON_LBN_SELCHANGE(IDC_LIST_PTN, OnSelchangeListPtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLCoAttb bZ[W nh

BOOL CLCoAttb::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	CWnd* pWnd;
	char sz[64];
	int n;
	
	//p^[ĨXg{bNX̐ݒ
	CListBox* pList=(CListBox*)GetDlgItem(IDC_LIST_PTN);
	if(m_pListPtn){
		pList->SendMessage(WM_SETREDRAW,FALSE,0);
		POSITION pos=m_pListPtn->GetHeadPosition();
		while(pos){
			CLCoPtn* pPtn=m_pListPtn->GetNext(pos);
			wsprintf(sz,"%dx%d  %s",pPtn->m_size.cx/10,pPtn->m_size.cy/10,pPtn->m_strName);
			int nIndex=pList->AddString(sz);
			pList->SetItemDataPtr(nIndex,pPtn);
		}
		pList->SendMessage(WM_SETREDRAW,TRUE,0);
	}
	

	//XTCYGfBbg{bNX̐ݒ
	_itoa(m_nX,sz,10);
	pWnd=GetDlgItem(IDC_EDIT_XSIZE);
	((CEdit*)pWnd)->LimitText(3);
	pWnd->SetWindowText(sz);

	//YTCYGfBbg{bNX̐ݒ
	_itoa(m_nY,sz,10);
	pWnd=GetDlgItem(IDC_EDIT_YSIZE);
	((CEdit*)pWnd)->LimitText(3);
	pWnd->SetWindowText(sz);

	//ԍvtBbNXGfBbg{bNX̐ݒ
	pWnd=GetDlgItem(IDC_EDIT_PREFIX);
	((CEdit*)pWnd)->LimitText(5);
	pWnd->SetWindowText(m_strPrefix);

	//ubNGfBbg{bNX̐ݒ
	_itoa(m_nBlock,sz,10);
	pWnd=GetDlgItem(IDC_EDIT_BLOCK);
	((CEdit*)pWnd)->LimitText(3);
	pWnd->SetWindowText(sz);

	//p^[gp`FbN{bNX̐ݒ
	if(m_pPtn==NULL) n=0; else n=1;
	pWnd=GetDlgItem(IDC_CHECK_USEPTN);
	((CButton*)pWnd)->SetCheck(n);
	if(!n)pList->EnableWindow(FALSE);
	else{
		pList->EnableWindow(TRUE);
		int nCount=pList->GetCount();
		int m;
		for(m=0;m<nCount;m++){
			CLCoPtn* pPtn=(CLCoPtn*)pList->GetItemDataPtr(m);
			if(!pPtn) break;
			if(pPtn==m_pPtn){
				pList->SetCurSel(m);
				break;
			}
		}
	}

	CString strClassName;

	strClassName=AfxRegisterWndClass(
		CS_VREDRAW|CS_HREDRAW,
		AfxGetApp()->LoadStandardCursor(IDC_ARROW), 
		(HBRUSH)GetStockObject(WHITE_BRUSH));	//wi͔


	m_wndPtnView.CreateEx(
		WS_EX_CLIENTEDGE,
		strClassName,
		"Ptn&View",		//&VɈӖ
		WS_CHILD | WS_VISIBLE | WS_VSCROLL |WS_HSCROLL,
		0,0,0,0,
		this->m_hWnd,
		(HMENU)IDC_PTNVIEW);
	
	SetItemSize();

	m_wndPtnView.SetPtn(m_pPtn);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


//up^[gpv`FbN{bNXꂽƂ̃nh
void CLCoAttb::OnCheckUseptn() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CButton* pCheck=(CButton*)GetDlgItem(IDC_CHECK_USEPTN);
	int n=pCheck->GetCheck();

	CListBox* pList=(CListBox*)GetDlgItem(IDC_LIST_PTN);
	if(!n){
		pList->EnableWindow(FALSE);
		pList->SetCurSel(-1);
		m_wndPtnView.SetPtn(NULL);
	}else{
		pList->EnableWindow(TRUE);
		int nCount=pList->GetCount();
		int m;
		int nX=GetX();
		int nY=GetY();
		for(m=0;m<nCount;m++){
			CLCoPtn* pPtn=(CLCoPtn*)pList->GetItemDataPtr(m);
			if(!pPtn) break;
			if(pPtn->m_size.cx/10 == nX && pPtn->m_size.cy/10 == nY){
				pList->SetCurSel(m);
				m_wndPtnView.SetPtn(pPtn);
				break;
			}
		}
	}
}

//GfBbg{bNXXl𓾂
int CLCoAttb::GetX()
{
	CWnd* pWnd=GetDlgItem(IDC_EDIT_XSIZE);
	CString str;
	pWnd->GetWindowText(str);
	return atoi(str);
}

//GfBbg{bNXYl𓾂
int CLCoAttb::GetY()
{
	CWnd* pWnd=GetDlgItem(IDC_EDIT_YSIZE);
	CString str;
	pWnd->GetWindowText(str);
	return atoi(str);
}

//GfBbg{bNXBlockl𓾂
int CLCoAttb::GetBlock()
{
	CWnd* pWnd=GetDlgItem(IDC_EDIT_BLOCK);
	CString str;
	pWnd->GetWindowText(str);
	return atoi(str);
}

void CLCoAttb::SetItemSize()
{
	CRect rc;

	CListBox* pList=(CListBox*)GetDlgItem(IDC_LIST_PTN);
	if(!pList) return;
	pList->GetWindowRect(&rc);
	ScreenToClient(&rc);
	int nMargin=rc.left;
	m_wndPtnView.MoveWindow(rc.right+nMargin,rc.top,
		m_sizeClient.cx-nMargin-(rc.right+nMargin),
		rc.bottom-rc.top);
}



void CLCoAttb::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	m_sizeClient.cx=cx;
	m_sizeClient.cy=cy;
	
}

void CLCoAttb::OnSelchangeListPtn() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CLCoPtn* pPtn;
	CListBox* pList=(CListBox*)GetDlgItem(IDC_LIST_PTN);
	
	int nIndex=pList->GetCurSel();
	if(nIndex==LB_ERR) pPtn=NULL;
	else pPtn=(CLCoPtn*)pList->GetItemDataPtr(nIndex);

	m_wndPtnView.SetPtn(pPtn);

}

void CLCoAttb::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	m_nX=GetX();
	if(m_nX<1 || m_nX>255){
		AfxMessageBox(IDS_PARTSIZE_XRANGE);
		return;
	}
	m_nY=GetY();
	if(m_nY<1 || m_nY>255){
		AfxMessageBox(IDS_PARTSIZE_YRANGE);
		return;
	}
	m_nBlock=GetBlock();
	if(m_nBlock<1 || m_nBlock>255){
		AfxMessageBox(IDS_PART_BLOCKRANGE);
		return;
	}

	CEdit* pEdit=(CEdit*)GetDlgItem(IDC_EDIT_PREFIX);
	pEdit->GetWindowText(m_strPrefix);
	
	CButton* pCheck=(CButton*)GetDlgItem(IDC_CHECK_USEPTN);
	int n=pCheck->GetCheck();
	if(!n){
		m_pPtn=NULL;
	}else{
		CListBox* pList=(CListBox*)GetDlgItem(IDC_LIST_PTN);
		int nIndex=pList->GetCurSel();
		if(nIndex==LB_ERR) m_pPtn=NULL;
		else m_pPtn=(CLCoPtn*)pList->GetItemDataPtr(nIndex);
	}

	CDialog::OnOK();
}
