///////////////////////////////////////////////////////////////
// RgNX CBSchComment ̓̒`s܂

#include "stdafx.h"
#include "BSch.h"

#include "BSchFont.h"
#include "Global.h"
#include "BSchObj.h"
#include "BSchCmnt.h"
#include "CmntAtrb.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define Y_OFFSET 2

IMPLEMENT_SERIAL(CBSchComment, CObject ,0)

/////////////////////////////////////////////////////////////////////////////
// CBSchComment VAC[[V
//  gĂȂit@C̓o͂WriteCE2() ReadCE2()ōsj
void CBSchComment::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
		//ar << m_p0;
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB
		//ar >> m_p0;
	}
}

//`
void CBSchComment::Draw(
	CDC* pDC,						//`
	DWORD dwMode,					//`惂[h
	int nVExt/*=1*/,				//\{(View)
	int nWExt/*=1*/,				//\{(Window)
	LPCRECT lprcClip /*=NULL*/)		//Nbv
{
	COLORREF col;
	//`F̌
	if(dwMode & DRAW_DARK)		col=COL_DARK;
	else if(dwMode & DRAW_XOR)	col=COL_XOR; 
	else						col=COL_COMMENT;
	if(m_dwType==COMMENT_SMALL){
		m_size=g_pFont->PutFont   (pDC,m_p0.x,m_p0.y-Y_OFFSET,m_psz,-1,col,dwMode,
			             FALSE,TRUE,nVExt,nWExt);
	}else{
		m_size=g_pFont->PutWinFont(pDC,m_p0.x,m_p0.y-Y_OFFSET,m_psz,-1,col,dwMode,
						nVExt,nWExt);
	}
	m_bSetSize=TRUE;
}


//~[
void CBSchComment::HMirror(int nXcenter)
{
	int nWidth;
	if(m_bSetSize){	//TCYZbgς
		nWidth = m_size.cx;
	}else{			//TCYZbgĂȂꍇCÊ̂z肵悻̒lԂ
		int nStrLen;
		if(m_psz) nStrLen=lstrlen(m_psz);
		else      nStrLen=0;
		nWidth = nStrLen*8;
	}
	m_p0.x = nXcenter*2 - (m_p0.x + nWidth);
}



//{̂LGAԂ
//{fB̃TCY̑AsiPOhbgj̗Ll
CRect CBSchComment::GetRect()
{
	CRect rc;
	int nStrLen;

	rc.left  =m_p0.x;        
	rc.bottom=m_p0.y-Y_OFFSET;
	if(m_bSetSize){	//TCYZbgς
		rc.top   =m_p0.y-m_size.cy-Y_OFFSET; 
		rc.right =m_p0.x+m_size.cx;
	}else{			//TCYZbgĂȂꍇCÊ̂z肵悻̒lԂ
		if(m_psz) nStrLen=lstrlen(m_psz);
		else      nStrLen=0;
		rc.right =m_p0.x+nStrLen*8;
		if(m_dwType==COMMENT_SMALL){
			rc.top   =m_p0.y-8-Y_OFFSET;
		}else{
			rc.top   =m_p0.y-16-Y_OFFSET;
		}
	}
	return rc;
}

//̈ʒu擾
CPoint CBSchComment::GetPointLT()
{
	return CPoint(m_p0.x,m_p0.y-10);
}



//w肷`Ɛ}ʗvf̑Î߂̏dȂ
DWORD CBSchComment::InArea(LPCRECT lpRect)
{
	CRect rc=GetRect();
	if(RectAndRect(&rc,lpRect))return INAREA_SELECT|INAREA_P0|INAREA_P1;
	else return 0;
}	

//w肷`Ɛ}ʗvf̕`̂߂̏dȂ
DWORD CBSchComment::InAreaDraw(LPCRECT lpRect,BOOL bAtrb/*=FALSE*/)
{
	if(!m_bSetSize)return INAREA_DRAW;
	CRect rc=GetRect();
	if(RectAndRect(&rc,lpRect))return INAREA_DRAW;
	else return 0;
}


//w肷_Ɛ}ʗvf̏dȂ
DWORD CBSchComment::InAreaPoint(CPoint* lpPoint,UINT nOption/*=0*/)
{
	CRect rc=GetRect();
	WORD wMag=PointAndRectMag(lpPoint,&rc);
	if(wMag) return (ON_RECTAREA |(DWORD)wMag);
	else return 0;
}

//Agr[gύXp̃_CAON
BOOL CBSchComment::DoAttributeDialog()
{
	CCmntAtrb dlg;
	dlg.m_rText=CString(m_psz);
	dlg.m_bUseSmallFont=(m_dwType==COMMENT_SMALL);
	if(dlg.DoModal()==IDCANCEL) return FALSE;
	if(dlg.m_bUseSmallFont)m_dwType=COMMENT_SMALL;
	else                   m_dwType=COMMENT_LARGE;
	delete[]m_psz;
	m_psz=new char[dlg.m_rText.GetLength()+1];
	lstrcpy(m_psz,dlg.m_rText);
	return TRUE;
}

//IuWFNg̕
CBSchObj* CBSchComment::Duplicate()
{
	CBSchComment* pObj=new CBSchComment;
	if(!pObj) return NULL;
	pObj->m_dwType		=this->m_dwType;
	pObj->m_dwStus		=this->m_dwStus;
	pObj->m_nMoveFrom	=this->m_nMoveFrom;
	pObj->m_p0			=this->m_p0;
	pObj->m_nLayer		=this->m_nLayer;
	if(this->m_psz){
		pObj->m_psz=new char[lstrlen(this->m_psz)+1];
		lstrcpy(pObj->m_psz,this->m_psz);
	}
	return (CBSchObj*)pObj;
}

//Rgɕݒ
void CBSchComment::SetString(LPCSTR psz)
{
	delete[]m_psz;
	m_psz=NULL;
	if(psz){
		int n=lstrlen(psz);
		m_psz=new char[n+1];
		lstrcpy(m_psz,psz);
	}
	m_bSetSize=FALSE;
}

//f[^Lǂ𒲂ׂ
BOOL CBSchComment::IsValid()
{
	if(!m_psz) return FALSE;
	if(lstrlen(m_psz)==0) return FALSE;
	return TRUE;
}	


////////////////////////////////////////////////////////////////////////////////
//CE2t@Co
#pragma pack(1)		//\̂̋EPoCgPʂɕύX

//t@Cւ̏
//TRUEBsFALSEԂ
//Rg̃wb_[ƃRĝQɕď
BOOL CBSchComment::WriteCE2(CFile* pFile,CPoint* pOrigin /* =NULL*/)
{
	int nStrLen,nx,ny;
	BOOL bResult=TRUE;

	if(!m_psz) return TRUE; 
	nStrLen=lstrlen(m_psz);
	if(nStrLen==0) return TRUE;

	if(nStrLen>63)nStrLen=63;		//

	struct{			//ݗp̍\
		BYTE	bId;			//ID
		BYTE	bStus;			//Xe[^X
		short	x;				//wW
		short	y;				//xW
		short   reserved1[2];	//\
		short	datasize;		//f[^̃TCY
		BYTE	btype;			//0:c8dot  1:c16dot
		BYTE	bcharcount;		//
	}ce2comment;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}
	ce2comment.bId  	  =CE2_COMMENT;
	//ce2comment.bStus	  =0;
	ce2comment.bStus	=(m_nLayer & 0x0F)<<4;	//1998/06/27
	ce2comment.x		  =m_p0.x-nx;
	ce2comment.y		  =m_p0.y-ny;
	ce2comment.datasize   =sizeof(ce2comment)+nStrLen;
	ce2comment.btype	  =(BYTE)(m_dwType&1);
	ce2comment.bcharcount =nStrLen;
	try{
		pFile->Write(&ce2comment,sizeof(ce2comment));
	}
	catch(CFileException *e){
		if(e->m_cause!=CFileException::none) bResult=FALSE;
		e->Delete();
	}
	
	if(bResult){
		try{
			pFile->Write(m_psz,nStrLen);
		}
		catch(CFileException *e){
			if(e->m_cause!=CFileException::none) bResult=FALSE;
			e->Delete();
		}
	}
	return bResult;
}



//t@C̓ǂݍ
BOOL CBSchComment::ReadCE2(CFile* pFile,BYTE bCE2Id,CPoint* pOrigin/* =NULL*/)
{
	int nx,ny,n;
	struct{			//ǂݍݗp̍\
		BYTE	bStus;			//Xe[^X
		short	x;				//wW
		short	y;				//xW
		short   reserved1[2];	//\
		short	datasize;		//f[^̃TCY
		BYTE	btype;			//0:c8dot  1:c16dot
		BYTE	bcharcount;		//
	}ce2comment;


	if(bCE2Id!=CE2_COMMENT) return FALSE;
	UINT uResult=pFile->Read(&ce2comment,sizeof(ce2comment));
	if(uResult<sizeof(ce2comment)) return FALSE;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}
    m_dwType=ce2comment.btype&1;
    m_dwStus=0;	
	m_p0.x=ce2comment.x+nx;
	m_p0.y=ce2comment.y+ny;
	m_bSetSize=FALSE;
	n=ce2comment.datasize-(sizeof(ce2comment)+1);	//u+1v͏ʂœǂݍݍς݂̂PoCg
	if(ce2comment.bcharcount>n){	//Rgf[^̃t@C̃TCYƕ
		TRACE("\n datasize error. CBSchComment::ReadCE2()");
		return FALSE;
	}
	m_psz=new char[ce2comment.bcharcount+1];	//̃m
	uResult=pFile->Read(m_psz,n);
	if(uResult<(UINT)n) return FALSE;	//LXgȂƎv
	*(m_psz+ce2comment.bcharcount)=0;
	//C[̐ݒ
	m_nLayer=(ce2comment.bStus & 0xF0)>>4;

	return TRUE;
}

#pragma pack()		//\̂̋EftHglɖ߂






