///////////////////////////////////////////////////////////////
// iNX BSchPart ̓̒`s܂

#include "stdafx.h"
#include <stdlib.h>		//_itoa()̂߂ɃCN[h
#include "BSch.h"

#include "SetLib.h"

//#include "BSchDoc.h"
//#include "BSchView.h"

#include "PartLib.h"
#include "BSchFont.h"
#include "Global.h"
#include "BSchObj.h"
#include "BSchPart.h"
#include "ReadERC.h"

#include "Pattern.h"

#include "PartAtrb.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_SERIAL(CBSchPart, CObject ,0)

	/**************************************************************************
		s̃mNrbg}bv
		
		     PinPtn[3][4][30]
		            |  |   |
		            |  |   +----zP̃oCg
		            |  +--------L T R B ̏
		            +-----------Clock,Negative,NegativeClock̏
		678901234567890
		...**.***......
		..*.**...*.....
		.*..*.....*....
		*...*.....*****		
		.*..*.....*....		
		..*.**...*.....
		...**.***......
	
	***************************************************************************/
static BYTE PinPtn[3][4][40]={

	{  //******  C L O C K  *****
		{
			// Clock L
			16,0,			//XTCY
			7,0,			//YTCY
			0x00,0x30,		//-3
			0x00,0x28,		//-2
			0x00,0x24,		//-1
			0xFF,0xE2,		//Center
			0x00,0x24,		//+1
			0x00,0x28,		//+2
			0x00,0x30		//+3
		},
	
		{
			// Clock T
			16,0,			//XTCY
			15,0,			//YTCY
			0x10,0,			//0 PinEnd
			0x10,0,			//1
			0x10,0,			//2
			0x10,0,			//3
			0x10,0,			//4
			0x10,0,			//5
			0x10,0,			//6
			0x10,0,			//7
			0x10,0,			//8
			0x10,0,			//9 
			0xFE,0,			//0 PartEdge
			0x82,0,			//1
			0x44,0,			//2
			0x28,0,			//3
			0x10,0			//4
		},
		
		{
			// Clock R
			16,0,			//XTCY
			7,0,			//YTCY
			0x18,0x00,		//-3
			0x28,0x00,		//-2
			0x48,0x00,		//-1
			0x8F,0xFE,		//Center
			0x48,0x00,		//+1
			0x28,0x00,		//+2
			0x18,0x00		//+3
		},
		
		{
			// Clock B
			16,0,			//XTCY
			15,0,			//YTCY
			0x10,0,			//6
			0x28,0,			//7
			0x44,0,			//8
			0x82,0,			//9
			0xFE,0,			//0 PartEdge
			0x10,0,			//1
			0x10,0,			//2
			0x10,0,			//3
			0x10,0,			//4
			0x10,0,			//5
			0x10,0,			//6
			0x10,0,			//7
			0x10,0,			//8
			0x10,0,			//9
			0x10,0			//0 PinEnd
		}
	},

	{  //******  N E G A T I V E *****
		{
			// Negtative L
			16,0,			//XTCY
			7,0,			//YTCY
			0x03,0x80,		//-3
			0x04,0x40,		//-2
			0x08,0x20,		//-1
			0xF8,0x20,		//Center
			0x08,0x20,		//+1
			0x04,0x40,		//+2
			0x03,0x80		//+3
		},
	
		{
			// Negtative T
			16,0,			//XTCY
			15,0,			//YTCY
			0x10,0,			//0 PinEnd
			0x10,0,			//1
			0x10,0,			//2
			0x10,0,			//3
			0x38,0,			//4
			0x44,0,			//5
			0x82,0,			//6
			0x82,0,			//7
			0x82,0,			//8
			0x44,0,			//9 
			0x38,0,			//0 PartEdge
			0,   0,			//1
			0,   0,			//2
			0,   0,			//3
			0,   0			//4
		},
		
		{
			// Negtative R
			16,0,			//XTCY
			7,0,			//YTCY
			0x03,0x80,		//-3
			0x04,0x40,		//-2
			0x08,0x20,		//-1
			0x08,0x3E,		//Center
			0x08,0x20,		//+1
			0x04,0x40,		//+2
			0x03,0x80		//+3
		},
		
		{
			// Negtative B
			16,0,			//XTCY
			15,0,			//YTCY
			0,   0,			//6
			0,   0,			//7
			0,   0,			//8
			0,   0,			//9
			0x38,0,			//0 PartEdge
			0x44,0,			//1
			0x82,0,			//2
			0x82,0,			//3
			0x82,0,			//4
			0x44,0,			//5
			0x38,0,			//6
			0x10,0,			//7
			0x10,0,			//8
			0x10,0,			//9
			0x10,0			//0 PinEnd
		}
	},


	{  //******  N E G A T I V E   C L O C K *****
		{
			// NegtativeClocl L
			16,0,			//XTCY
			7,0,			//YTCY
			0x03,0xB0,		//-3
			0x04,0x68,		//-2
			0x08,0x24,		//-1
			0xF8,0x22,		//Center
			0x08,0x24,		//+1
			0x04,0x68,		//+2
			0x03,0xB0		//+3
		},
	
		{
			// NegtativeClock T
			16,0,			//XTCY
			15,0,			//YTCY
			0x10,0,			//0 PinEnd
			0x10,0,			//1
			0x10,0,			//2
			0x10,0,			//3
			0x38,0,			//4
			0x44,0,			//5
			0x82,0,			//6
			0x82,0,			//7
			0x82,0,			//8
			0x44,0,			//9 
			0xFE,0,			//0 PartEdge
			0x82,0,			//1
			0x44,0,			//2
			0x28,0,			//3
			0x10,0			//4
		},
		
		{
			// NegtativeClock R
			16,0,			//XTCY
			7,0,			//YTCY
			0x1B,0x80,		//-3
			0x2C,0x40,		//-2
			0x48,0x20,		//-1
			0x88,0x3E,		//Center
			0x48,0x20,		//+1
			0x2C,0x40,		//+2
			0x1B,0x80		//+3
		},
		
		{
			// NegtativeClock B
			16,0,			//XTCY
			15,0,			//YTCY
			0x10,0,			//6
			0x28,0,			//7
			0x44,0,			//8
			0x82,0,			//9
			0xFE,0,			//0 PartEdge
			0x44,0,			//1
			0x82,0,			//2
			0x82,0,			//3
			0x82,0,			//4
			0x44,0,			//5
			0x38,0,			//6
			0x10,0,			//7
			0x10,0,			//8
			0x10,0,			//9
			0x10,0			//0 PinEnd
		}
	}
};





/////////////////////////////////////////////////////////////////////////////
// CBSchPart VAC[[V
//  gĂȂit@C̓o͂WriteCE2() ReadCE2()ōsj
void CBSchPart::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
		//ar << m_p0;
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB
		//ar >> m_p0;
	}
}

//s̏I[̐}ʍW𓾂
//                        m_nRot(]p)
//              (0)        (1)        (2)        (3)
// m_bMirror                               
//                                
//  (FALSE)    
//                                
//                                         
//
//
//                                         
//                                
//  (TRUE )    
//                                
//                                         
BOOL CBSchPart::GetPinXY(DWORD dwStus,CPoint *ppoint,int* pnLTRB)
{
	int x,y,nOffset;
	int nLTRB=((HIWORD(dwStus)&3)+m_nRot)&3;
	if(m_bMirror){
		if(nLTRB==PIN_LOC_L)		nLTRB=PIN_LOC_R;
		else if(nLTRB==PIN_LOC_R)	nLTRB=PIN_LOC_L;
	}
	nOffset=(dwStus&0xff)*10;
	if(nLTRB==PIN_LOC_L || nLTRB==PIN_LOC_R){//sEɑ݂Ƃ
		if(m_nRot<=1){//]pPȉȂ΃ŝW͏ォ̃ItZbg
			y=-(m_sizeBody.cy-1)+nOffset;
		}else{		  //]pQȏȂ΃ŝW͉̃ItZbg
			y=-nOffset;
		}
		if(nLTRB==PIN_LOC_L){//sȂ炘W͍
			x=-(m_sizeBody.cx-1)-10;
		}else{
			x=10;
		}
	}else{//sォɑ݂Ƃ
		if(   (!m_bMirror && (m_nRot==0 || m_nRot==3))    //̏̂Ƃ
			||( m_bMirror && (m_nRot==1 || m_nRot==2)) ){ //ŝW͍̃ItZbg
			x=-(m_sizeBody.cx-1)+nOffset;
		}else{		//ȊȌł̓ŝW͉ẼItZbg
			x=-nOffset;
		}
		if(nLTRB==PIN_LOC_T){//sȂ炙W͏
			y=-(m_sizeBody.cy-1)-10;
		}else{
			y=10;
		}
	}
	*ppoint=CPoint(m_p0.x+x,m_p0.y+y);
	*pnLTRB=nLTRB;
	return TRUE;
}


//i̕`
void CBSchPart::DrawBody(
	CDC* pDC,						//`
	DWORD dwMode,					//`惂[h
	int nVExt/*=1*/,				//\{(View)
	int nWExt/*=1*/)				//\{(Window)
{
	int x,y,l,t,r,b;
	x=m_p0.x-m_sizeBody.cx+1;
	y=m_p0.y-m_sizeBody.cy+1;
	//̏㉺E̍W
	l=(x*nVExt)/nWExt;				//`捶W
	t=(y*nVExt)/nWExt;				//`W
	r=(m_p0.x*nVExt)/nWExt;			//`EW
	b=(m_p0.y*nVExt)/nWExt;			//`扺W

	int nOldDrawMode,nNewDrawMode;
	COLORREF col;
	BYTE* pPtn=m_pPartIndex->GetPattern();
	
	//`̕`
	//p^[݂ȂꍇAip^[݂Ăjg`w肪Ƃ͋``
	if(pPtn==NULL || g_bDisplayPartFrame!=FALSE){
		if(pPtn==NULL) col=COL_PART; else col=COL_PART_FRAME;
		CPen penNew;
		CPen* ppenOld;
		//`惂[hɂăy̎ށEFCOPY or XORݒ肷
		if(dwMode & DRAW_DARK){
			penNew.CreatePen(PS_SOLID,0,COL_DARK);
			nNewDrawMode=R2_COPYPEN;
		}else if(dwMode & DRAW_ON){
			penNew.CreatePen(PS_SOLID,0,col);
			nNewDrawMode=R2_COPYPEN;
		}else if(dwMode & DRAW_OFF){
			penNew.CreatePen(PS_SOLID,0,RGB(0,0,0));
			nNewDrawMode=R2_COPYPEN;
		}else if(dwMode & DRAW_XOR){
			penNew.CreatePen(PS_SOLID,0,COL_XOR);
			nNewDrawMode=R2_XORPEN;
		}else{
			TRACE("\nsȕ`惂[h(CBSchPart::DrawBody())");
			return;
		}
		ppenOld=pDC->SelectObject(&penNew);			//쐬y̑I
		nOldDrawMode=pDC->SetROP2(nNewDrawMode);	//`惂[h̐ݒ
		pDC->MoveTo(l,t);
		pDC->LineTo(r,t); pDC->LineTo(r,b);			//Sӂ̕`
		pDC->LineTo(l,b); pDC->LineTo(l,t);
		pDC->SetROP2(nOldDrawMode);					//`惂[h̕A
		pDC->SelectObject(ppenOld);					//y̕A
	}
	if(pPtn!=NULL){	//p^[
		//`惂[hɂĐFݒ肷
		if(dwMode & DRAW_DARK)		col=COL_DARK;
		else if(dwMode & DRAW_XOR)	col=COL_XOR;
		else						col=COL_PART;	
		g_Pattern.PutPtn(pDC,x,y,pPtn,col,dwMode,m_nRot,m_bMirror,nVExt,nWExt);
	}
}



//s̕`
void CBSchPart::DrawPin(
	CDC* pDC,						//`
	DWORD dwMode,					//`惂[h
	DWORD dwPinStus,				//sXe[^X
	LPCSTR pszPinName,				//s
	LPCSTR pszPinNum,				//s
	int nVExt/*=1*/,				//\{(View)
	int nWExt/*=1*/,				//\{(Window)
	LPCRECT lprcClip/* =NULL */)	//Nbv

{
	COLORREF col;
	int nLTRB;
	CPoint ptPin1,ptPin; //ptPin1GetPinXY()Ńs̏I[Wɏ
	GetPinXY(dwPinStus,&ptPin1,&nLTRB);	//s̏I[̐}ʍW𓾂
	WORD wPinStusHi=HIWORD(dwPinStus);  //s̏ʃ[h
	//WORD wNumPfix=HIWORD(dwPinNum);		//sԍ̏ʃ[h
	int nPinNameLen=-1;					//s̕
	BOOL  bBodyOnly=(dwMode & DRAW_FAST)||(nVExt!=nWExt);//ꂪTRUÊƂsAsԍ`悵Ȃ
	
	//s̕`͈ӊOƎԂBNbṽ`FbNs
	if(lprcClip!=NULL){	//NbvNULLȂm[`FbN
		CRect rc;
		int nPinNameArea=15;//s߂镝(sI[̒l)
		int nPinNumArea=0;	//sԍ߂镝(sI[̒lASԂ30Ō߂)
		int nPinNumHeight=4; //sԍ߂鍂
		if(!bBodyOnly){
			if(pszPinName){
				nPinNameLen=lstrlen(pszPinName); 
				nPinNameArea=nPinNameLen*8+15;//s߂镝̐ݒ
			}
			if(pszPinNum!=NULL && pszPinNum[0]=='+'){
				nPinNumArea= (lstrlen(pszPinNum)-1)*8+15;
				nPinNumHeight=9;
			}
		}
		//s߂`͈͂̐ݒ
		switch(nLTRB){
		case PIN_LOC_L: rc.left=ptPin1.x-nPinNumArea;    rc.top=ptPin1.y-nPinNumHeight;
						rc.right=ptPin1.x+nPinNameArea;  rc.bottom=ptPin1.y+4;				break;
		case PIN_LOC_T: rc.left=ptPin1.x-nPinNumHeight;  rc.top=ptPin1.y-nPinNumArea;
						rc.right=ptPin1.x+4;             rc.bottom=ptPin1.y+nPinNameArea;	break;
		case PIN_LOC_R: rc.left=ptPin1.x-nPinNameArea;   rc.top=ptPin1.y-nPinNumHeight;
						rc.right=ptPin1.x+nPinNumArea;   rc.bottom=ptPin1.y+4;              break;
		case PIN_LOC_B: rc.left=ptPin1.x-nPinNumHeight;  rc.top=ptPin1.y-nPinNameArea;
						rc.right=ptPin1.x+4;             rc.bottom=ptPin1.y+nPinNumArea;    break;
		}
		//dȂ̃`FbN
		if(!RectAndRect(&rc,lprcClip)){
	//		TRACE("x");
			return;
		}
	//	TRACE("o");
	}

	

	
	
	//s{̂̕`
	//  Erbg}bvsgꍇ
	//  E`̃sgꍇ
	if(    (wPinStusHi & (PIN_TYPE_CLOCK | PIN_TYPE_NEGATIVE))	//_NbÑs...
        // && ((dwMode & DRAW_FAST)==0)        //DRAW_FASTłȂ...  ̏1997/01/05ɊO
		&& (nVExt==nWExt)){					//{`̂ƂɃrbg}bvsg
		int nPinType=(((wPinStusHi & (PIN_TYPE_CLOCK | PIN_TYPE_NEGATIVE))>>14)&3)-1;
		//`惂[hɂĐFݒ肷
		if(dwMode & DRAW_DARK)		col=COL_DARK;
		else if(dwMode & DRAW_XOR)	col=COL_XOR;
		else						col=COL_PART;	
		//sʒuɂĕ`ʒuݒ肷
		ptPin=ptPin1;
		switch(nLTRB){
		case PIN_LOC_L: ptPin.y-=3;             break;
		case PIN_LOC_T:	ptPin.x-=3;             break;
		case PIN_LOC_R:	ptPin.x-=14; ptPin.y-=3; break;
		case PIN_LOC_B:	ptPin.x-=3; ptPin.y-=14; break;
		}	
		g_Pattern.PutPtn(pDC,ptPin.x,ptPin.y,PinPtn[nPinType][nLTRB],col,dwMode);
	}else{
		CPen penNew;
		CPen* ppenOld;
		int nOldDrawMode,nNewDrawMode;
		ptPin=ptPin1;
		//ptPins̍̍Wɂ
		switch(nLTRB){
		case PIN_LOC_L: ptPin.x+=10; break;
		case PIN_LOC_T: ptPin.y+=10; break;
		case PIN_LOC_R: ptPin.x-=10; break;
		case PIN_LOC_B: ptPin.y-=10; break;
		}
		//ʏ̍Wɕϊ
		ptPin.x  =(ptPin.x  *nVExt)/nWExt;
		ptPin.y  =(ptPin.y  *nVExt)/nWExt;
		ptPin1.x =(ptPin1.x *nVExt)/nWExt;
		ptPin1.y =(ptPin1.y *nVExt)/nWExt;
		//`惂[hɂăy̎ށEFCOPY or XORݒ肷
		if(dwMode & DRAW_DARK){
			penNew.CreatePen(PS_SOLID,0,COL_DARK);
			nNewDrawMode=R2_COPYPEN;
		}else if(dwMode & DRAW_ON){
			penNew.CreatePen(PS_SOLID,0,COL_PART);
			nNewDrawMode=R2_COPYPEN;
		}else if(dwMode & DRAW_OFF){
			penNew.CreatePen(PS_SOLID,0,RGB(0,0,0));
			nNewDrawMode=R2_COPYPEN;
		}else if(dwMode & DRAW_XOR){
			penNew.CreatePen(PS_SOLID,0,COL_XOR);
			nNewDrawMode=R2_XORPEN;
		}else{
			TRACE("\nsȕ`惂[h(CBSchPart::DrawPin())");
			return;
		}
		ppenOld=pDC->SelectObject(&penNew);			//쐬y̑I
		nOldDrawMode=pDC->SetROP2(nNewDrawMode);	//`惂[h̐ݒ
		pDC->MoveTo(ptPin1);
		pDC->LineTo(ptPin);
		pDC->SetROP2(nOldDrawMode);					//`惂[h̕A
		pDC->SelectObject(ppenOld);					//y̕A
	}
	///////////////////////////////////////////////////////////////////////////
	// DRAW_FAST[hk`惂[hł̓s{̂̕`悾Ȃ̂łŏI // 
	///////////////////////////////////////////////////////////////////////////
	if(bBodyOnly) return;	//߂

	BOOL bPointFront;	//wW̑ÔƂTRUE
	BOOL bVert;			//̂ƂTRUE;
	//s̕`
	if(pszPinName!=NULL){
		if(dwMode & DRAW_DARK) col=COL_DARK;
		else if(dwMode & DRAW_XOR) col=COL_XOR;
		else col=COL_PART_PINNAME;
		ptPin=ptPin1;		//ptPin̍WPutFont
		switch(nLTRB){
		case PIN_LOC_L:
			bPointFront=TRUE;
			bVert      =FALSE;
			ptPin.x+=15;
			ptPin.y+=4;
			break;
		case PIN_LOC_T:
			bPointFront=FALSE;
			bVert      =TRUE;
			ptPin.x+=4;
			ptPin.y+=15;
			break;
		case PIN_LOC_R:
			bPointFront=FALSE;
			bVert      =FALSE;
			ptPin.x-=15;
			ptPin.y+=4;
			break;
		case PIN_LOC_B:
			bPointFront=TRUE;
			bVert      =TRUE;
			ptPin.x+=4;
			ptPin.y-=15;
			break;
		}
		g_pFont->PutFont(pDC,ptPin.x,ptPin.y,pszPinName,nPinNameLen,
			             col,dwMode,bVert,bPointFront);
	}

	//sԍ̕`
	int nPinOffset;				//sԍ̕`ʒu̓s̃Xe[^Xŕω
	if(pszPinNum!=NULL && pszPinNum[0]=='+'){		//sԍ\tOĂΕ`
		//`F̌
		if(dwMode & DRAW_DARK)		col=COL_DARK;
		else if(dwMode & DRAW_XOR)	col=COL_XOR; 
		else						col=COL_PART_PINNUM;
		//ItZbg̐ݒ
		if(wPinStusHi & PIN_TYPE_SMALL) nPinOffset=8; else nPinOffset=2;
		ptPin=ptPin1;		//ptPin̍WPutFont
		switch(nLTRB){
		case PIN_LOC_L:
			bPointFront=FALSE;
			bVert      =FALSE;
			ptPin.x+=nPinOffset;
			ptPin.y-=2;
			break;
		case PIN_LOC_T:
			bPointFront=TRUE;
			bVert      =TRUE;
			ptPin.x-=2;
			ptPin.y+=nPinOffset;
			break;
		case PIN_LOC_R:
			bPointFront=TRUE;
			bVert      =FALSE;
			ptPin.x-=nPinOffset;
			ptPin.y-=2;
			break;
		case PIN_LOC_B:
			bPointFront=FALSE;
			bVert      =TRUE;
			ptPin.x-=2;
			ptPin.y-=nPinOffset;
			break;
		}
		g_pFont->PutFont(pDC,ptPin.x,ptPin.y,pszPinNum+1,-1,
			             col,dwMode,bVert,bPointFront);
	}
}




//`
void CBSchPart::Draw(
	CDC* pDC,						//`
	DWORD dwMode,					//`惂[h
	int nVExt/*=1*/,				//\{(View)
	int nWExt/*=1*/,				//\{(Window)
	LPCRECT lprcClip /*=NULL*/)		//Nbv
{
	int n,nPin;
	DWORD dwPinStus;
	const char* pszPinName;
	const char* pszPinNum;
	
	//`vf̎wtOׂOFFȂP`ƌȂĂׂĕ`
	if((dwMode & (INAREA_PARTBODY|INAREA_PARTNAME|INAREA_PARTNUM))==0){
		dwMode |= (INAREA_PARTBODY|INAREA_PARTNAME|INAREA_PARTNUM);
	}

	//i{̂̕`
	if(dwMode & INAREA_PARTBODY){
		DrawBody(pDC,dwMode,nVExt,nWExt);//̕`
		nPin=m_pPartIndex->GetPinCount();//s𓾂
		for(n=0;n<nPin;n++){	//s̐s̕`JԂ
			dwPinStus=m_pPartIndex->GetPinStatus(n);	//s̏𓾂
			if(dwMode & DRAW_FAST){	//DRAW_FASTł̓sAsԍ`悵Ȃ
				pszPinName=NULL;		    //sNULL
				pszPinNum =NULL;
			}else{					//sAsԍ`悷ꍇ
				pszPinName=m_pPartIndex->GetPinName(n,NULL);	//sւ̃|C^𓾂
				pszPinNum =m_pPartIndex->GetPinNum(n,m_nBlock); //sԍ𓾂
			}
			DrawPin(pDC,dwMode,dwPinStus,pszPinName,pszPinNum,nVExt,nWExt,lprcClip);//s̕`
		}
	}
	/////////////////////////////////////////////////////////////////
	// DRAW_FASTł͕iAiԍ`悵Ȃ̂ł܂łŏI //
	/////////////////////////////////////////////////////////////////
	if(dwMode & DRAW_FAST) return;	//߂
	COLORREF col;
	int x,y;
	//i̕`
	if( (dwMode & INAREA_PARTNAME) && g_bPrintPartName){
		//`F̌
		if(dwMode & DRAW_DARK)		col=COL_DARK;
		else if(dwMode & DRAW_XOR)	col=COL_XOR; 
		else col=COL_PART_NAME;
		//W̐ݒ
		x=m_p0.x+m_ptName.x;
		y=m_p0.y+m_ptName.y;
		g_pFont->PutFont(pDC,x,y-2,m_pszName,-1,col,dwMode,FALSE,TRUE,nVExt,nWExt);
	}
	//iԍ̕`
	if( (dwMode & INAREA_PARTNUM) && g_bPrintPartNum){
		//`F̌
		if(dwMode & DRAW_DARK)		col=COL_DARK;
		else if(dwMode & DRAW_XOR)	col=COL_XOR; 
		else						col=COL_PART_NUM;
		//W̐ݒ
		x=m_p0.x+m_ptNum.x;
		y=m_p0.y+m_ptNum.y;
		g_pFont->PutFont(pDC,x,y-2,m_pszNum,-1,col,dwMode,FALSE,TRUE,nVExt,nWExt);
	}
}

//{̂LGAԂ
//{fB̃TCY̑AsiPOhbgj̗Ll
CRect CBSchPart::GetRect()
{
	CRect rc;
	int n;
	if(m_bitLTRB & BITLTRB_L) n=10; else n=0;
	rc.left  =m_p0.x-(m_sizeBody.cx-1)  -n;
	if(m_bitLTRB & BITLTRB_T) n=10; else n=0;
	rc.top   =m_p0.y-(m_sizeBody.cy-1)  -n;
	if(m_bitLTRB & BITLTRB_R) n=10; else n=0;
	rc.right =m_p0.x +n;
	if(m_bitLTRB & BITLTRB_B) n=10; else n=0;
	rc.bottom=m_p0.y +n;
	return rc;
}

//iAiԍ܂߂LGAԂ 1999/02/10
CRect CBSchPart::GetRectAll()
{
	CRect rc;
	int n;
	if(m_bitLTRB & BITLTRB_L) n=40; else n=0;
	rc.left  =m_p0.x-(m_sizeBody.cx-1)  -n;
	if(m_bitLTRB & BITLTRB_T) n=40; else n=0;
	rc.top   =m_p0.y-(m_sizeBody.cy-1)  -n;
	if(m_bitLTRB & BITLTRB_R) n=40; else n=0;
	rc.right =m_p0.x +n;
	if(m_bitLTRB & BITLTRB_B) n=40; else n=0;
	rc.bottom=m_p0.y +n;

	CRect rcLabel;
	int nStrlen;

	nStrlen=lstrlen(m_pszName);
	if(nStrlen){
		rcLabel = CRect(m_p0.x+m_ptName.x,			 m_p0.y+m_ptName.y-9,
						m_p0.x+m_ptName.x+nStrlen*8,m_p0.y+m_ptName.y-1);
		rc = rc | rcLabel;
	}
	nStrlen=lstrlen(m_pszNum);
	if(nStrlen){
		rcLabel = CRect(m_p0.x+m_ptNum.x,			m_p0.y+m_ptNum.y-9,
						m_p0.x+m_ptNum.x+nStrlen*8,m_p0.y+m_ptNum.y-1);
		rc = rc | rcLabel;
	}
	return rc;
}

//̈ʒu擾
CPoint CBSchPart::GetPointLT()
{
	int l,t,n;
	if(m_bitLTRB & BITLTRB_L) n=10; else n=0;
	l  =m_p0.x-(m_sizeBody.cx-1)  -n;
	if(m_bitLTRB & BITLTRB_T) n=10; else n=0;
	t  =m_p0.y-(m_sizeBody.cy-1)  -n;


	return CPoint(l,t);
}

//w肷`Ɛ}ʗvf̑Î߂̏dȂ
//Î߂ɂ͓Ƃ̏dȂ肾`FbN
DWORD CBSchPart::InArea(LPCRECT lpRect)
{
	CRect rc(m_p0.x-(m_sizeBody.cx-1),	//W
		     m_p0.y-(m_sizeBody.cy-1),	//W
			 m_p0.x,					//EW
			 m_p0.y);					//W
	if(RectAndRect(&rc,lpRect))return INAREA_SELECT|INAREA_P0|INAREA_P1;
	else return 0;
}	

//w肷`Ɛ}ʗvf̕`̂߂̏dȂ
DWORD CBSchPart::InAreaDraw(LPCRECT lpRect,BOOL bAtrb/*=FALSE*/)
{
	DWORD dwResult=0;
	CRect rc;
	int nLadd=0,nTadd=0,nRadd=0,nBadd=0;
	//{̂̕`GA̐ݒ
	if(bAtrb){//iAiԍ`悷ꍇ́AsԍAs̕`͈͂l
		if(m_bitLTRB & BITLTRB_L){ nLadd=40; nTadd=10; nBadd=5;}
		if(m_bitLTRB & BITLTRB_R){ nRadd=40; nTadd=10; nBadd=5;}
		if(m_bitLTRB & BITLTRB_T){ nTadd=40;if(nLadd<10) nLadd=10;
											if(nRadd<5)  nRadd=5;}
		if(m_bitLTRB & BITLTRB_B){ nBadd=40;if(nLadd<10) nLadd=10;
											if(nRadd<5)  nRadd=5;}
	}else{//iAiԍ`悵Ȃꍇ̓s̒l
		if(m_bitLTRB & BITLTRB_L)nLadd=10;
		if(m_bitLTRB & BITLTRB_R)nRadd=10;
		if(m_bitLTRB & BITLTRB_T)nTadd=10;
		if(m_bitLTRB & BITLTRB_B)nBadd=10;
	}
	rc.left  =m_p0.x-(m_sizeBody.cx-1)  -nLadd;
	rc.top   =m_p0.y-(m_sizeBody.cy-1)  -nTadd;
	rc.right =m_p0.x +nRadd;
	rc.bottom=m_p0.y +nBadd;
	if(RectAndRect(&rc,lpRect)) dwResult|=INAREA_PARTBODY;
	if(bAtrb){
		int nStrlen;
		//iƂ̏dȂ`FbN
		nStrlen=lstrlen(m_pszName);
		rc=CRect(m_p0.x+m_ptName.x,			 m_p0.y+m_ptName.y-7,
				 m_p0.x+m_ptName.x+nStrlen*8,m_p0.y+m_ptName.y);
		if(RectAndRect(&rc,lpRect)) dwResult|=INAREA_PARTNAME;
		//iԍƏdȂ`FbN
		nStrlen=lstrlen(m_pszNum);
		rc=CRect(m_p0.x+m_ptNum.x,			m_p0.y+m_ptNum.y-7,
				 m_p0.x+m_ptNum.x+nStrlen*8,m_p0.y+m_ptNum.y);
		if(RectAndRect(&rc,lpRect)) dwResult|=INAREA_PARTNUM;
	}
	return dwResult;
}

//w肷_Ɛ}ʗvf̏dȂ
DWORD CBSchPart::InAreaPoint(CPoint* lpPoint,UINT nOption/*=0*/)
{
	DWORD dwResult=0;

	int nLadd=0,nTadd=0,nRadd=0,nBadd=0;
	//GA̐ݒ
	CRect rc;
	if(nOption & INAREAPOINT_TMPDATA){
		rc=GetRect();
	}else{
		rc=CRect(m_p0.x-(m_sizeBody.cx-1),	//W
			     m_p0.y-(m_sizeBody.cy-1),	//W
				 m_p0.x,					//EW
				 m_p0.y);					//W
	}
	WORD wMag=PointAndRectMag(lpPoint,&rc);
	if(wMag)dwResult=(ON_RECTAREA |(DWORD)wMag);
	if(nOption & INAREAPOINT_ATTRIB){
		int nStrlen;
		//iƂ̏dȂ`FbN
		if(m_pszName){
			nStrlen=lstrlen(m_pszName);
			if(nStrlen){
				rc=CRect(m_p0.x+m_ptName.x,			 m_p0.y+m_ptName.y-9,
						 m_p0.x+m_ptName.x+nStrlen*8,m_p0.y+m_ptName.y-1);
				if(PointAndRect(lpPoint,&rc)) dwResult|=ON_PARTNAME;
			}
		}
		//iԍƏdȂ`FbN
		if(m_pszNum){
			nStrlen=lstrlen(m_pszNum);
			if(nStrlen){
				rc=CRect(m_p0.x+m_ptNum.x,			m_p0.y+m_ptNum.y-9,
						 m_p0.x+m_ptNum.x+nStrlen*8,m_p0.y+m_ptNum.y-1);
				if(PointAndRect(lpPoint,&rc)) dwResult|=ON_PARTNUM;
			}
		}
	}
	return dwResult;
}

//sԂ
int CBSchPart::GetPinCount()
{
	return m_pPartIndex->GetPinCount();
}


//nԖڂ̃s̈ʒu𓾂B
BOOL CBSchPart::GetPinPosition(int nPin,CPoint* pptPin)
{
	int nLTRB;
	DWORD dwPinStus=m_pPartIndex->GetPinStatus(nPin);	//s̏𓾂
	if(dwPinStus==0xFFFFFFFF) return FALSE;// nPin͈̔͊OG[
	GetPinXY(dwPinStus,pptPin,&nLTRB);	//s̏I[̐}ʍW𓾂
	return TRUE;
}


//]
//̃o[ϐ𑀍삷
//m_sizeBody cxcy̓ꊷ
//m_bitLTRB  ʂSrbg[e[g
//m_ptName   ftHg̈ʒuɃZbg
//m_ptNum	 ftHg̈ʒuɃZbg
//m_nRot     őlR̃CNg
void CBSchPart::Rotate()
{
	int n;
	n=m_sizeBody.cx;
	m_sizeBody.cx=m_sizeBody.cy;
	m_sizeBody.cy=n;

	//1999/07/15 Version 0.74 LTRBrbg̐U镑̏C
	if(!m_bMirror){
		m_bitLTRB<<=1;
		if(m_bitLTRB & 0x10) m_bitLTRB |=1;
		m_bitLTRB &= 0xf;
	}else{
		if(m_bitLTRB & 0x1) m_bitLTRB |= 0x10;
		m_bitLTRB>>=1;
		m_bitLTRB &= 0xf;
	}

	m_ptName.x=PARTNAME_X;
	m_ptName.y=PARTNAME_Y;
	m_ptNum.x =PARTNUM_X;
	m_ptNum.y =PARTNUM_Y;

	m_nRot++;
	m_nRot&=3;
}

//~[
void CBSchPart::HMirror(int nXcenter)
{
	UINT n;
	n=m_bitLTRB & (BITLTRB_T | BITLTRB_B);
	if(m_bitLTRB & BITLTRB_L) n |= BITLTRB_R;
	if(m_bitLTRB & BITLTRB_R) n |= BITLTRB_L;
	m_bitLTRB=n;
	m_bMirror=(m_bMirror==FALSE);
	m_p0.x = nXcenter*2 - (m_p0.x - (m_sizeBody.cx-1));

	int nStrlen;
	int nWidth;

	if(m_pszName){
		nStrlen=lstrlen(m_pszName);
		nWidth=nStrlen*8-1;
		m_ptName.x = -(m_sizeBody.cx-2 + nWidth + m_ptName.x);
	}
	if(m_pszNum){
		nStrlen=lstrlen(m_pszNum);
		nWidth=nStrlen*8;
		m_ptNum.x = -(m_sizeBody.cx-2 + nWidth + m_ptNum.x);
	}
}

//E]
//̃o[ϐ𑀍삷
//m_bitLTRB  LrbgRrbgꊷ
//m_ptName   ftHg̈ʒuɃZbg
//m_ptNum	 ftHg̈ʒuɃZbg
//m_bMirror  gO
void CBSchPart::Mirror()
{
	UINT n;

	n=m_bitLTRB & (BITLTRB_T | BITLTRB_B);
	if(m_bitLTRB & BITLTRB_L) n |= BITLTRB_R;
	if(m_bitLTRB & BITLTRB_R) n |= BITLTRB_L;
	m_bitLTRB=n;
	
	m_ptName.x=PARTNAME_X;
	m_ptName.y=PARTNAME_Y;
	m_ptNum.x =PARTNUM_X;
	m_ptNum.y =PARTNUM_Y;

	m_bMirror=(m_bMirror==FALSE);
}

//Agr[gύXp̃_CAON
BOOL CBSchPart::DoAttributeDialog()
{
	CPartAtrb dlg;
	dlg.m_nBlock   =m_nBlock+1;
//    dlg.m_nBlockMax=m_pPartIndex->GetBlock();
	dlg.m_pPartIndex=m_pPartIndex;
	dlg.m_rPartNum=CString(m_pszNum);
	dlg.m_rPartName=CString(m_pszName);
	dlg.m_rOrgName=CString(m_pPartIndex->GetName(NULL));
	if(dlg.DoModal()==IDCANCEL) return FALSE;
	//ubN̒l̍Đݒ
	m_nBlock=dlg.m_nBlock-1;
	//iԍ̍Đݒ
	delete[]m_pszNum;
	m_pszNum=new char[dlg.m_rPartNum.GetLength()+1];
	lstrcpy(m_pszNum,dlg.m_rPartNum);
	//i̍Đݒ
	delete[]m_pszName;
	m_pszName=new char[dlg.m_rPartName.GetLength()+1];
	lstrcpy(m_pszName,dlg.m_rPartName);
	return TRUE;
}

//IuWFNg̕
CBSchObj* CBSchPart::Duplicate()
{
	CBSchPart* pObj=new CBSchPart;
	if(!pObj) return NULL;
	pObj->m_dwType		=this->m_dwType;
	pObj->m_dwStus		=this->m_dwStus;
	pObj->m_nMoveFrom	=this->m_nMoveFrom;
	pObj->m_p0			=this->m_p0;
	pObj->m_sizeBody	=this->m_sizeBody;
	pObj->m_bitLTRB		=this->m_bitLTRB;
	pObj->m_pPartIndex	=this->m_pPartIndex;
	pObj->m_nLayer		=this->m_nLayer;
	if(this->m_pszName){
		pObj->m_pszName=new char[lstrlen(this->m_pszName)+1];
		lstrcpy(pObj->m_pszName,this->m_pszName);
	}
	pObj->m_ptName		=this->m_ptName;		
	if(this->m_pszNum){
		pObj->m_pszNum=new char[lstrlen(this->m_pszNum)+1];
		lstrcpy(pObj->m_pszNum,this->m_pszNum);
	}
	pObj->m_ptNum		=this->m_ptNum;
	pObj->m_nBlock		=this->m_nBlock;
	pObj->m_bMirror		=this->m_bMirror;
	pObj->m_nRot		=this->m_nRot;
	return (CBSchObj*)pObj;
}


//CBSchPartL̊֐
//ïʒu炷
BOOL CBSchPart::ShiftPartName(CPoint* pOrigin)
{
	m_ptName.Offset(*pOrigin);
	return TRUE;
}

//iԍ̈ʒu炷
BOOL CBSchPart::ShiftPartNum(CPoint* pOrigin)
{
	m_ptNum.Offset(*pOrigin);
	return TRUE;
}

//1999/08/02
//Cu̕iւ̃|C^̂肩
void CBSchPart::ReplacePartIndex(CPartIndex* pPartIndex)
{
	if(!pPartIndex) return;
	m_pPartIndex=pPartIndex;	//Cu̕iւ̃|C^Zbg
}


//֐
//Cu̕iւ̃|C^Zbg
//  ̌ACȕƂɃo[ϐ
void CBSchPart::SetPartIndex(CPartIndex* pPartIndex)
{
	char sz[64];
	int n;
	if(!pPartIndex) return;
	m_pPartIndex=pPartIndex;	//Cu̕iւ̃|C^Zbg
	//m_sizeBody̐ݒ
	m_sizeBody=m_pPartIndex->GetSize();	//ObhPʂł̃TCY𓾂
	m_sizeBody.cx=m_sizeBody.cx*10+1;	//PObh=10hbgŕϊ
	m_sizeBody.cy=m_sizeBody.cy*10+1;
	//m_bitLTRB̐ݒ
	m_bitLTRB=m_pPartIndex->GetBitLTRB();
	//i̐ݒ
	m_pPartIndex->GetName(sz);	//ftHg̕ǐĂяo
	n=lstrlen(sz);
	m_pszName=new char[n+1];
	lstrcpy(m_pszName,sz);
	*(m_pszName+n)=0;
	//iʒu̐ݒ
	m_ptName.x=PARTNAME_X;
	m_ptName.y=PARTNAME_Y;
	//iԍ̐ݒ
	m_pPartIndex->GetRef(sz);	//ftHg̕iԍ̌Ăяo
	if(sz[0]=='-') n=0;
	else n=lstrlen(sz);
	m_pszNum=new char[n+1];
	if(n)lstrcpy(m_pszNum,sz);
	*(m_pszNum+n)=0;
	//iԍʒu̐ݒ
	m_ptNum.x =PARTNUM_X;
	m_ptNum.y =PARTNUM_Y;
	//ubNԍ̐ݒ
	m_nBlock=0;
	//E]tO̐ݒ
	m_bMirror=FALSE;
	//]p̐ݒ
	m_nRot=0;
}

//f[^Lǂ𒲂ׂ
BOOL CBSchPart::IsValid()
{
	if(m_pPartIndex==NULL) return FALSE;
	else return TRUE;
}


////////////////////////////////////////////////////////////////////////////////
//CE2t@Co
#pragma pack(1)		//\̂̋EPoCgPʂɕύX

//t@Cւ̏
//TRUEBsFALSEԂ
BOOL CBSchPart::WriteCE2(CFile* pFile,CPoint* pOrigin /* =NULL*/)
{
	int i,n,nx,ny;
	BOOL bResult=TRUE;
	char sz[64];
	char* ps;
	char* pd;
	
	struct{			//ݗp̍\
		BYTE	bId;			//ID
		BYTE	bStus;			//Xe[^X
		short	x;				//wW
		short	y;				//xW
		WORD	reserved1[2];	//\
		BYTE	bDire;			//A~[
		BYTE	bBlock;			//ubNԍ
		char	passtrName[16];	//i
		short	nNameX;			//îwW
		short	nNameY;			//îxW
		char	passtrNum[8];	//iԍ
		short	nNumX;			//iԍ̂wW
		short	nNumY;			//iԍ̂xW
		char	szDefaultName[16];	//ftHg̕i
	}ce2part;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}

	ce2part.bId  	=CE2_PART;
//	ce2part.bStus	=0;
	ce2part.bStus	=(m_nLayer & 0x0F)<<4;	//1998/06/27
	ce2part.x		=m_p0.x-nx;
	ce2part.y		=m_p0.y-ny;
	ce2part.reserved1[0]=0;				//\
	ce2part.reserved1[1]=0;				//\
	ce2part.bDire=m_nRot&3;				//
	if(m_bMirror)ce2part.bDire |= 0x04;	//~[
	ce2part.bBlock=m_nBlock&0xff;		//ubNԍ
	if(m_pszName)n=lstrlen(m_pszName);	//i̕
	else n=0;
	if(n>15)n=15;						//
	ce2part.passtrName[0]=n;			//obt@̐擪ɕ			
	ps=m_pszName;						//̃Rs[
	pd=&(ce2part.passtrName[1]);
	for(i=0;i<n;i++) *pd++=*ps++;
//	lstrcpyn(&(ce2part.passtrName[1]),m_pszName,n);//̃Rs[
	ce2part.nNameX=(short)m_ptName.x;	//îwW
	ce2part.nNameY=(short)m_ptName.y;	//îxW
	if(m_pszNum)n=lstrlen(m_pszNum);	//iԍ̕
	else n=0;
	if(n>7)n=7;							//
	ce2part.passtrNum[0]=n;				//obt@̐擪ɕ			
	ps=m_pszNum;						//̃Rs[
	pd=&(ce2part.passtrNum[1]);
	for(i=0;i<n;i++) *pd++=*ps++;
//	lstrcpyn(&(ce2part.passtrNum[1]),m_pszNum,n);//̃Rs[
	ce2part.nNumX=(short)m_ptNum.x;		//iԍ̂wW
	ce2part.nNumY=(short)m_ptNum.y;		//iԍ̂xW
	
	m_pPartIndex->GetName(sz);			//ftHg̕ǐĂяo
	lstrcpyn(ce2part.szDefaultName,sz,16);	//ftHg̕i̐ݒ

	try{
		pFile->Write(&ce2part,sizeof(ce2part));
	}
	catch(CFileException *e){
		if(e->m_cause!=CFileException::none) bResult=FALSE;
		e->Delete();
	}
	return bResult;
}



//t@C̓ǂݍ
BOOL CBSchPart::ReadCE2(CFile* pFile,BYTE bCE2Id,CPoint* pOrigin/* =NULL*/)
{
	int nx,ny,n;
	UINT dw;
	struct{			//ǂݍݗp̍\
		BYTE	bStus;			//Xe[^X
		short	x;				//wW
		short	y;				//xW
		WORD	reserved1[2];	//\
		BYTE	bDire;			//A~[
		BYTE	bBlock;			//ubNԍ
		char	passtrName[16];	//i
		short	nNameX;			//îwW
		short	nNameY;			//îxW
		char	passtrNum[8];	//iԍ
		short	nNumX;			//iԍ̂wW
		short	nNumY;			//iԍ̂xW
		char	szDefaultName[16];	//ftHg̕i
	}ce2part;

	if(bCE2Id!=CE2_PART) return FALSE;
	UINT uResult=pFile->Read(&ce2part,sizeof(ce2part));
	if(uResult<sizeof(ce2part)) return FALSE;

	m_pPartIndex=g_SearchPartIndex(ce2part.szDefaultName);
	if(m_pPartIndex==NULL){//Cuɕi񂪖...
		m_dwStus=STUS_DELETE;	//f[^ɂĂ܂B
		if(!g_ReadCE2ERC.IsRegistered(ce2part.szDefaultName)){//G[`FbNXgɖo^Ȃ
			g_ReadCE2ERC.Add(ce2part.szDefaultName);//G[`FbNXgɓo^
			CString rString;
			//bZ[W{bNXp̃bZ[W̍쐬
			AfxFormatString1(rString,IDS_NOT_FOUND_PART,ce2part.szDefaultName); 
  			if(AfxMessageBox(rString,MB_OKCANCEL|MB_ICONEXCLAMATION)==IDCANCEL) return FALSE;
		}
		return TRUE;
	}
	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}
    m_dwType=0;
    m_dwStus=0;	
	m_p0.x=ce2part.x+nx;
	m_p0.y=ce2part.y+ny;

	//m_sizeBody̐ݒ
	m_sizeBody=m_pPartIndex->GetSize();	//ObhPʂł̃TCY𓾂
	m_sizeBody.cx=m_sizeBody.cx*10+1;	//PObh=10hbgŕϊ
	m_sizeBody.cy=m_sizeBody.cy*10+1;
	//E]tO̐ݒ
	m_bMirror=(ce2part.bDire & 4)!=0;
	//]p̐ݒ
	m_nRot=ce2part.bDire & 3;
	if(m_nRot & 1){	//]p90x270x̂Ƃm_sizeBodyxyւ
		n=m_sizeBody.cx;
		m_sizeBody.cx=m_sizeBody.cy;
		m_sizeBody.cy=n;
	}

	//m_bitLTRB̐ݒ
	dw=m_pPartIndex->GetBitLTRB();
	dw<<=m_nRot;
	dw=(dw & 0xF)|((dw & 0xF0)>>4);
	if(m_bMirror){
		m_bitLTRB=dw & (BITLTRB_T | BITLTRB_B);
		if(dw & BITLTRB_L)  m_bitLTRB |= BITLTRB_R;
		if(dw & BITLTRB_R)  m_bitLTRB |= BITLTRB_L;
	}else{
		m_bitLTRB=dw;
	}
	//i̐ݒ
	n=ce2part.passtrName[0];		//𓾂
	if(n>15)n=15;					//ő啶
	m_pszName=new char[n+1];		//̃m
	lstrcpyn(m_pszName,&(ce2part.passtrName[1]),n+1);//񕡎
	*(m_pszName+n)=0;
	//iʒu̐ݒ
	m_ptName.x=ce2part.nNameX;
	m_ptName.y=ce2part.nNameY;
	//iԍ̐ݒ
	n=ce2part.passtrNum[0];			//𓾂
	if(n>7)n=7;						//ő啶
	m_pszNum=new char[n+1];			//̃m
	lstrcpyn(m_pszNum,&(ce2part.passtrNum[1]),n+1);//񕡎
	*(m_pszNum+n)=0;
	//iԍʒu̐ݒ
	m_ptNum.x =ce2part.nNumX;
	m_ptNum.y =ce2part.nNumY;
	//ubNԍ̐ݒ
	m_nBlock=ce2part.bBlock;
	//C[̐ݒ
	m_nLayer=(ce2part.bStus & 0xF0)>>4;
	return TRUE;
}

#pragma pack()		//\̂̋EftHglɖ߂
