// BSchView.cpp : CBSchView NX̓̒`s܂B
// 2 of 2

#include "stdafx.h"
#include <stdlib.h> //abs()̂߂ɃCN[h 
#include "BSch.h"

#include "SetLib.h"

#include "BSchObj.h"
#include "BSchJunc.h"
#include "BSchEntr.h"

#include "BSchDoc.h"
#include "BSchView.h"

#include "PartLib.h"
#include "BSchFont.h"
#include "Global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//Obh̕`
void CBSchView::DrawSheetGrid(CDC* pDC)
{
	if(m_nVExt!=m_nWExt || !g_bDisplayGrid) return;
	int nx,ny;
	ny=((m_rcClip.top+9)/10)*10;
	while(ny<m_rcClip.bottom){
		nx=((m_rcClip.left+9)/10)*10;
		while(nx<m_rcClip.right){
			pDC->SetPixel(nx,ny,COL_SHEET_GRID);
			nx+=10;
		}
		ny+=10;
	}
}


//}ʘg̐W̕`
void CBSchView::DrawSheetFrameCharH(CDC* pDC,COLORREF col,int ny,int nWidth,UINT nMode)
{
	int x=100;
	char c='A';
	while(x<nWidth){
		g_pFont->PutFont(
				pDC,				//o͐̃foCXReLXg
				x,ny,				//o͈ʒu
				&c,					//o͕
				1,					//
				col,				//`F
				nMode);				//`惂[h
		x+=200;
		c++;
	}
}

//}ʘg̐W̕`
void CBSchView::DrawSheetFrameCharV(CDC* pDC,COLORREF col,int nx,int nWidth,UINT nMode)
{
	int y=100;
	char c='1';
	while(y<nWidth){
		g_pFont->PutFont(
				pDC,				//o͐̃foCXReLXg
				nx,y,				//o͈ʒu
				&c,					//o͕
				1,					//
				col,				//`F
				nMode);				//`惂[h
		y+=200;
		if(c=='9') c='0';
		else c++;
	}
}

//}ʘg̕`
//dwMode DRAW_ONDRAW_OFF݂̂Lȋ͖j
void CBSchView::DrawSheetFrame(CDC* pDC,DWORD dwMode)
{
	CSize sizeOrg,size;				//}ʂ̃TCY
	COLORREF col;					//g̕`F
	CRect rcOutside, rcInside;		//g̍W
	int nFrameWidth=10;				//g̕

	//W̐ݒ
	nFrameWidth=nFrameWidth*m_nVExt/m_nWExt;	//Y[ɑΉgɕϊ
	CBSchDoc* pDoc = GetDocument();				//hLg̃|C^𓾂
	pDoc->GetSheetSize(&sizeOrg);				//}ʃTCY𓾂
	size=sizeOrg;
	BSchPtoLP(&size);
	rcOutside=CRect(0,0,size.cx-1,size.cy-1);	//Og̍W̐ݒ
	rcInside =CRect(nFrameWidth,nFrameWidth,	//g̍W̐ݒ
		size.cx-nFrameWidth,size.cy-nFrameWidth);
	//`F̐ݒ	
	if(dwMode & DRAW_ON) col=COL_SHEET_FRAME;	//DRAW_ONłBSch.HŒ`F
	else				 col=RGB(0,0,0);		//DRAW_OFFł͍ł̕`
	
	//g̕`
	CPen* pPen=new CPen(PS_SOLID,1,col);
	pPen=pDC->SelectObject(pPen);	//쐬y̑I
	if(m_rcClip.left<=10){				//g̕`
		pDC->MoveTo(rcInside.left,rcInside.top);
		pDC->LineTo(rcInside.left,rcInside.bottom);
		if(m_nVExt==m_nWExt)	//{`̂Ƃɂ͍W`
			DrawSheetFrameCharV(pDC,col,rcOutside.left+2,sizeOrg.cy,dwMode);
		if(m_rcClip.left<=0){			//Og̕`
			pDC->MoveTo(rcOutside.left,rcOutside.top);
			pDC->LineTo(rcOutside.left,rcOutside.bottom);
		}
	}
	if(m_rcClip.top<=10){				//g̕`
		pDC->MoveTo(rcInside.left,rcInside.top);
		pDC->LineTo(rcInside.right,rcInside.top);
		if(m_nVExt==m_nWExt)	//{`̂Ƃɂ͍W`
			DrawSheetFrameCharH(pDC,col,rcInside.top-2,sizeOrg.cx,dwMode);
		if(m_rcClip.top<=0){			//Og̕`
			pDC->MoveTo(rcOutside.left,rcOutside.top);
			pDC->LineTo(rcOutside.right,rcOutside.top);
		}
	}
	if(m_rcClip.right>=size.cx-10){		//Eg̕`
		pDC->MoveTo(rcInside.right,rcInside.top);
		pDC->LineTo(rcInside.right,rcInside.bottom+1);		//I_₤
		if(m_nVExt==m_nWExt)	//{`̂Ƃɂ͍W`
			DrawSheetFrameCharV(pDC,col,rcInside.right+1,sizeOrg.cy,dwMode);
		if(m_rcClip.right>=size.cx-1){	//EOg̕`
			pDC->MoveTo(rcOutside.right,rcOutside.top);
			pDC->LineTo(rcOutside.right,rcOutside.bottom+1);//I_₤
		}
	}
	if(m_rcClip.bottom>=size.cy-10){		//g̕`
		pDC->MoveTo(rcInside.left,rcInside.bottom);
		pDC->LineTo(rcInside.right,rcInside.bottom);
		if(m_nVExt==m_nWExt)	//{`̂Ƃɂ͍W`
			DrawSheetFrameCharH(pDC,col,rcOutside.bottom-1,sizeOrg.cx,dwMode);
		if(m_rcClip.bottom>=size.cy-1){
			pDC->MoveTo(rcOutside.left,rcOutside.bottom);
			pDC->LineTo(rcOutside.right,rcOutside.bottom);
		}
	}
	pPen=pDC->SelectObject(pPen);	//y̕A
	delete pPen;					//쐬y̍폜
}


//w胊Xgf[^̕`
void CBSchView::DrawListData(CDC* pDC,CObList* pList,DWORD dwMode,DWORD dwOption /* =0 */)
{
	POSITION pos;
	CBSchObj* pObj;
	DWORD dwStus;
	DWORD dwDrawFlag;
	static WORD wLayerTable[]={	0x0001,0x0002,0x0004,0x0008,
								0x0010,0x0020,0x0040,0x0080,
								0x0100,0x0200,0x0400,0x0800,
								0x1000,0x2000,0x4000,0x8000};
	WORD wShowLayer;
	int  nEditLayer;
	BOOL fEditHigh;

	if(!pDC || !pList) return;

	CBSchDoc* pDoc = GetDocument();
	wShowLayer = pDoc->m_wShowLayer;
	nEditLayer = pDoc->m_nEditLayer;
	fEditHigh  = pDoc->m_fEditHighLight;

	pos =pList->GetHeadPosition();				//擪̗vf𓾂
	while(pos){
		pObj=(CBSchObj*)pList->GetNext(pos);//݂pos̗vf̃|C^ƎPOSITIONl𓾂
		if(!pObj){		//{NULL͗L蓾Ȃ
			TRACE("\nInvalid BSchObj* (CBSchView::DrawTmpData())");
			return;
		}
		dwStus=pObj->GetStus();				//|C^̗vf̃Xe[^X𓾂
		if(dwStus & STUS_DELETE) continue;	//Xe[^Xf[^Ȃ`悵Ȃ
		if(!(dwOption & DRAW_ALL_LAYER)){
			if(!(wShowLayer & wLayerTable[pObj->GetLayer()]) ) continue;//`惌C[łȂΕ`悵Ȃ
		}
		
		//if(dwOption){	//IvVOłȂƂ...
		if(dwOption & DRAG_LINE_ONLY){	//БIf[^`悷w肪LȂ...
			if(     (dwStus & STUS_P0) &&  (dwStus & STUS_P1)
				|| !(dwStus & STUS_P0) && !(dwStus & STUS_P1)) continue;//БIf[^ȊOȂ`悵Ȃ
		}
		//}
		dwDrawFlag=pObj->InAreaDraw(&m_rcClip,TRUE);
		if(dwDrawFlag){
			//DWORD dwDarkFlag=0;
			//if( (dwMode & DRAW_ON)	&& fEditHigh ){
			//	int n= pObj->GetLayer();
			//	if(n != nEditLayer) dwDarkFlag = DRAW_DARK;
			//}
			//pObj->Draw(pDC,dwMode|dwDrawFlag|dwDarkFlag,m_nVExt,m_nWExt,&m_rcClip);//`
			pObj->Draw(pDC,dwMode|dwDrawFlag,m_nVExt,m_nWExt,&m_rcClip);//`
		}
	}
}



//Cf[^̕`
void CBSchView::DrawMainData(CDC* pDC,CBSchDoc* pDoc,DWORD dwMode)
{
	int n;
	CObList* pMainData;
	if(!pDC || !pDoc) return;


	if(pDoc->m_fEditHighLight && dwMode & DRAW_ON){
		WORD wShowLayerOrg	= pDoc->m_wShowLayer;
		WORD wEditLayer = 0x01 << pDoc->m_nEditLayer;

		//ŏɕҏWC[ȊÕC[`悷
		pDoc->m_wShowLayer = wShowLayerOrg & ~wEditLayer;
		for(n=0;n<MAX_MAINDATA;n++){
			if((pMainData=pDoc->GetMainData(n))==NULL) break;	//Cf[^̃Xg͂܂
			DrawListData(pDC,pMainData,dwMode | DRAW_DARK);
		}
		//ォҏWC[`悷
		pDoc->m_wShowLayer = wEditLayer;
		for(n=0;n<MAX_MAINDATA;n++){
			if((pMainData=pDoc->GetMainData(n))==NULL) break;	//Cf[^̃Xg͂܂
			DrawListData(pDC,pMainData,dwMode);
		}
		pDoc->m_wShowLayer = wShowLayerOrg;//\C[ϐ̕A
	}else{
		for(n=0;n<MAX_MAINDATA;n++){
			if((pMainData=pDoc->GetMainData(n))==NULL) break;	//Cf[^̃Xg͂܂
			DrawListData(pDC,pMainData,dwMode);
		}
	}
}

//ꎞf[^̕`
//dwModeDRAW_XOR̂ƂAbDrawLB
//      bDrawTRUÊƂ`
//             FALSÊƂ
//dwModeDRAW_OFF̂ƂAm_bDrawTmpDataNA(FALSE)B
//  (..)
//    *1  uDrawTmpData()ɓnpDCOnPrepareDC()ʂĂ̂
//        XN[Or[ɍ킹ăEChĚ_삳Ă̂ł
//        ȂH ł́AƂɂč쐬 dcMem _ړĂ̂ł
//        ȂHv Ǝv̂ŁAŏ CClientDCgB ֌WȂ悤B
//        ̂߁A폜AnꂽpDCƂdcMem쐬B  
void CBSchView::DrawTmpData(CDC* pDC,CBSchDoc* pDoc,DWORD dwMode,BOOL bDraw/*=TRUE*/)
{
	CObList* pTmpData;
	//XOR`ŁAwłłɏς݂Ȃ牽Ȃ
	if((dwMode&DRAW_XOR) && bDraw==FALSE && m_bDrawTmpData==FALSE){
	//	TRACE("\nBSChView::DrawTmpData() #4");
		return;
	}
	if(!pDC || !pDoc){ 
	//	TRACE("\nBSChView::DrawTmpData() #3");
		return;
	}
	UINT nDrawAllBit;
	if(dwMode & DRAW_ON) nDrawAllBit=0;
	else				 nDrawAllBit=DRAW_ALL_LAYER;

	if(m_pBmpTmpCache && (dwMode & DRAW_XOR)){//LbVLȂ...
		CRect rc=pDoc->GetTmpRect();	//ꎞf[^̊O𓾂
	//	CPoint point=CPoint((rc.left/10)*10,(rc.top/10)*10);
		CPoint point=CPoint(rc.left-m_sizeTmpCacheOffset.cx,
			                rc.top -m_sizeTmpCacheOffset.cy);
		BSchPtoLP(&point);					//}ʍW_Wɕϊ
		BSchPtoLP(&rc);					//}ʍW_Wɕϊ
//	*1	CClientDC dc(this);				//NCAgGÃfoCXReLXg𓾂
		CDC dcMem;						//foCXReLXgIuWFNg̍쐬
//	*1	dcMem.CreateCompatibleDC(&dc);	//NCAgGAƌ݊̂郁foCXReLXg
		dcMem.CreateCompatibleDC(pDC);	//NCAgGAƌ݊̂郁foCXReLXg
		dcMem.SelectObject(m_pBmpTmpCache);
		COLORREF colOldBk	= pDC->SetBkColor(0);		//BkColor̐ݒ
		COLORREF colOldText	= pDC->SetTextColor(COL_XOR);	//TextColor̐ݒ
		pDC->BitBlt(point.x,point.y,						//Rs[W
					rc.right-rc.left+20,rc.bottom-rc.top+20,//A
					&dcMem,									//Rs[foCXReLXg
					0,0,									//Rs[W
					//m_pointTmpCacheOrigin.x,m_pointTmpCacheOrigin.y,//Rs[W
					SRCINVERT);
		pDC->SetBkColor(colOldBk);								//BkColor̕A
		pDC->SetTextColor(colOldText);							//TextColor̕A
		if((pTmpData=pDoc->GetTmpList())==NULL){			//ꎞf[^̃Xg𓾂
	//		TRACE("\nBSChView::DrawTmpData() #1");
			return;
		}
		DrawListData(pDC,pTmpData,dwMode,nDrawAllBit|DRAG_LINE_ONLY);	//ꎞf[^̃Xg̕`
	}else{
		if((pTmpData=pDoc->GetTmpList())==NULL){		//ꎞf[^̃Xg𓾂
	//		TRACE("\nBSChView::DrawTmpData() #2");
			return;
		}
		DrawListData(pDC,pTmpData,dwMode,nDrawAllBit);	//ꎞf[^̃Xg̕`
	}
	if(dwMode & DRAW_XOR)m_bDrawTmpData=bDraw;
	else m_bDrawTmpData=FALSE;
}


//ꎞf[^̘g̕`
//̏ꍇ͘g`悵Ȃ
//   Eꎞf[^݂Ȃꍇ
//bDrawTRUÊƂ`
//       FALSÊƂ
void CBSchView::DrawTmpDataFrame(CDC* pDC,CBSchDoc* pDoc,BOOL bDraw/*=TRUE*/)
{
	RECT rc;
	if(bDraw==FALSE && m_bDrawTmpDataFrame==FALSE) return;
	if(!pDC || !pDoc) return;
	UINT nTmpFlag=pDoc->GetTmpDataFlag();
//	if(		!nTmpFlag	//iPj
//		||	 (nTmpFlag & TMPDATA_SINGLE)&& !(nTmpFlag & TMPDATA_FOR_DRAG) ){//iQj
//		m_bDrawTmpDataFrame=FALSE;//`tONAĂ
//		return;
//	}
	if(!nTmpFlag){	//iPj
		m_bDrawTmpDataFrame=FALSE;//`tONAĂ
		return;
	}
	rc=pDoc->GetTmpRect();		//ꎞf[^̊O𓾂
	BSchPtoLP(&rc);				//}ʍW_Wɕϊ
	rc.left-=1; rc.top-=1; rc.right+=2; rc.bottom+=2;
	pDC->DrawFocusRect(&rc);	//_g̕`
	m_bDrawTmpDataFrame=bDraw;	
}

//I𒆂̓_g̕`
//bDrawTRUÊƂ`
//       FALSÊƂ
void CBSchView::DrawCrossCursor(CDC* pDC,BOOL bDraw/*=TRUE*/)
{
	//TRACE("DrawCrossCursor %d\n",bDraw);

	if(!g_bUseCrossCursor){
		m_bDrawCrossCursor=FALSE;
		return;
	}

	if(bDraw==FALSE && m_bDrawCrossCursor==FALSE) return;//włłɏς݂Ȃ牽Ȃ
	RECT rc;
//	rc=CRect(CPoint(-10,-10),m_ptMouse);
	rc=CRect(-10,m_ptMouse.y,5000,3000);

	BSchPtoLP(&rc);				//}ʍW_Wɕϊ
	pDC->DrawFocusRect(&rc);	//_g̕`
//	rc=CRect(m_ptMouse,CPoint(5000,3000));
	rc=CRect(m_ptMouse.x,-10,5000,3000);

	BSchPtoLP(&rc);				//}ʍW_Wɕϊ
	pDC->DrawFocusRect(&rc);	//_g̕`
	m_bDrawCrossCursor=bDraw;
}
	

//I𒆂̓_g̕`
//bDrawTRUÊƂ`
//       FALSÊƂ
void CBSchView::DrawSelectFrame(CDC* pDC,BOOL bDraw/*=TRUE*/)
{
	RECT rc;
	if(bDraw==FALSE && m_bDrawSelectFrame==FALSE) return;//włłɏς݂Ȃ牽Ȃ
	g_MakeRECT(&m_ptMoveFrom,&m_ptMoveTo,&rc);	//_g̐}ʏ̍W𓾂
	BSchPtoLP(&rc);				//}ʍW_Wɕϊ
	pDC->DrawFocusRect(&rc);	//_g̕`
	m_bDrawSelectFrame=bDraw;	//gOłȂ_ɒ 1996/12/01
}

//ꎞf[^`̂߂̃LbVrbg}bv̏
//  ELbVjĈꎞf[^p̃rbg}bv|C^NULLݒ
//  Eꎞf[^PIuWFNgȂ牽Ȃ
//  Eꎞf[^̊O̕`TCYƓrbg}bv쐬
//  Eŏ
//  EhbOŕВ[_ړf[^ăLbVɕ`
BOOL CBSchView::PrepareBmpTmpCache()
{
	TRACE("\nCalled CBSchView::PrepareBmpTmpCache()");	//R[mFfobOR[h
	delete m_pBmpTmpCache; m_pBmpTmpCache=NULL;	//ꎞf[^`LbVrbg}bv̉

	CBSchDoc* pDoc = GetDocument();	//hLg̃|C^𓾂

	UINT nTmpFlag=pDoc->GetTmpDataFlag();
	if(  !nTmpFlag
	   ||(nTmpFlag & TMPDATA_SINGLE)&&!(nTmpFlag & TMPDATA_FOR_DRAG)){
		TRACE("\nCanceled CBSchView::PrepareBmpTmpCache()");
		return FALSE;//ꎞf[^PIuWFNgȂ牽Ȃ
	}
	CRect rc=pDoc->GetTmpRect();	//ꎞf[^̊O𓾂
	CSize sizeBmp=CSize(rc.right-rc.left,rc.bottom-rc.top);	//쐬rbg}bv̐}ʍWTCY
	BSchPtoLP(&sizeBmp);			//}ʍW_Wɕϊ
	sizeBmp.cx+=20;
	sizeBmp.cy+=20;
	if(sizeBmp.cx>3000 || sizeBmp.cy>2000) return FALSE;	//쐬ׂrbg}bv傫ꍇ͍쐬Ȃ
	m_pBmpTmpCache=new CBitmap;		//rbg}bvIuWFNg new 
	if(!m_pBmpTmpCache->CreateBitmap(sizeBmp.cx,sizeBmp.cy,1,1,NULL)){//KvȃTCỸmNrbg}bv쐬
		//쐬Ɏs...
		delete m_pBmpTmpCache; m_pBmpTmpCache=NULL;	//ꎞf[^`LbVrbg}bv̉
		return FALSE;				//߂
	}
	COLORREF colBk;
	CBitmap* pOldBmp;
	CClientDC dc(this);				//NCAgGÃfoCXReLXg𓾂
	CDC dcMem;						//foCXReLXgIuWFNg̍쐬
	dcMem.CreateCompatibleDC(&dc);	//NCAgGAƌ݊̂郁foCXReLXg
	colBk=dcMem.GetBkColor();
	pOldBmp=dcMem.SelectObject(m_pBmpTmpCache);
	//dcMem.PatBlt(0,0,sizeBmp.cx,sizeBmp.cy,WHITENESS);//ŏ
	dcMem.FillSolidRect(0,0,sizeBmp.cx,sizeBmp.cy,RGB(255,255,255));//ŏ
	dcMem.SetBkColor(colBk);
	//쐬̃rbg}bvɈꎞf[^`
	CObList* pListTmp=pDoc->GetTmpList();//ꎞf[^̃Xg𓾂
	if(!pListTmp){
		TRACE("\nERROR CBSchView::PrepareBmpTmpCache()");
		delete m_pBmpTmpCache; m_pBmpTmpCache=NULL;	//ꎞf[^`LbVrbg}bv̉
		return FALSE;				//߂
	}
	//ۂ̕`
	CBSchObj* pObj;
	DWORD dwStus;
	CPoint offset2=CPoint((rc.left/10)*10,(rc.top/10)*10);
	CPoint offset1=-offset2;

	m_sizeTmpCacheOffset.cx=rc.left-offset2.x;
	m_sizeTmpCacheOffset.cy=rc.top-offset2.y;

	HCURSOR hCursor;
	hCursor=AfxGetApp()->LoadStandardCursor(IDC_WAIT);//vJ[\
	hCursor=::SetCursor(hCursor);


	POSITION pos =pListTmp->GetHeadPosition();				//擪̗vf𓾂
	while(pos){
		pObj=(CBSchObj*)pListTmp->GetNext(pos);	//݂pos̗vf̃|C^ƎPOSITIONl𓾂
		dwStus=pObj->GetStus();					//|C^̗vf̃Xe[^X𓾂
		if(dwStus & STUS_DELETE) continue;		//f[^Ȃ`悵Ȃ
		if(    (dwStus & STUS_P0) && !(dwStus & STUS_P1)
		   || !(dwStus & STUS_P0) &&  (dwStus & STUS_P1)) continue;//БIf[^Ȃ`悵Ȃ
		pObj->Shift(&offset1);
		pObj->Draw(&dcMem,DRAW_OFF|DRAW_FAST|INAREA_DRAW,m_nVExt,m_nWExt);		//`
		pObj->Shift(&offset2);
	}
	dcMem.SelectObject(pOldBmp);
	hCursor=::SetCursor(hCursor);

	return TRUE;
}


//Վf[^̕`
//dwModeDRAW_XOR̂ƂAbDrawLB
//      bDrawTRUÊƂ`
//             FALSÊƂ
//dwModeDRAW_OFF̂ƂAm_bDrawTmpDataNA(FALSE)B
void CBSchView::DrawOccasional(CDC* pDC,BOOL bDraw/*=TRUE*/)
{
	//XOR`ŁAwłłɏς݂Ȃ牽Ȃ
	if(bDraw==FALSE && m_bDrawOccasional==FALSE) return;
	if(!pDC) return;
	CPoint point;
	CPen* ppenNew;
	CPen* ppenOld;
	int nOldDrawMode;
	
	//E̕`
	if(m_nCurrentTool==ID_TOOL_WIRE || m_nCurrentTool==ID_TOOL_BUS){
		nOldDrawMode=pDC->SetROP2(R2_XORPEN);	//`惂[h̐ݒ
		int nWidth=1;
		if(m_nCurrentTool==ID_TOOL_BUS) nWidth=3;
		//y̏
		ppenNew=new CPen;
		ppenNew->CreatePen(PS_SOLID,nWidth,COL_XOR);
		ppenOld=pDC->SelectObject(ppenNew);
		//n_ւMoveTo;
		point=m_ptMoveFrom;
		BSchPtoLP(&point);
		pDC->MoveTo(point);
		//Ԃ̓_Wݒ肵Đ`
		if(m_bWireHorizon1st){		//ɐ
			point.x=m_ptMoveTo.x;
			point.y=m_ptMoveFrom.y;
		}else{
			point.x=m_ptMoveFrom.x;
			point.y=m_ptMoveTo.y;
		}
		BSchPtoLP(&point);
		pDC->LineTo(point);
		//I_ւ̐`;
		point=m_ptMoveTo;
		BSchPtoLP(&point);
		pDC->LineTo(point);
		pDC->SelectObject(ppenOld);
		delete ppenNew;	//y̏
		pDC->SetROP2(nOldDrawMode);	//`惂[h̕A
//j̕`
	}else if(m_nCurrentTool==ID_TOOL_DASH){
		nOldDrawMode=pDC->SetROP2(R2_XORPEN);	//`惂[h̐ݒ
		//߃[h̐ݒ
		int nOldBkMode=pDC->SetBkMode(TRANSPARENT);
		//jy̏
		ppenNew=new CPen;
		ppenNew->CreatePen(PS_DOT,1,COL_XOR);
		ppenOld=pDC->SelectObject(ppenNew);
		//n_ւMoveTo;
		point=m_ptMoveFrom;
		BSchPtoLP(&point);
		pDC->MoveTo(point);
		//I_ւ̐`;
		point=m_ptMoveTo;
		BSchPtoLP(&point);
		pDC->LineTo(point);
		pDC->SelectObject(ppenOld);
		delete ppenNew;	//jy̏
		pDC->SetBkMode(nOldBkMode);//߃[h̕A
		pDC->SetROP2(nOldDrawMode);	//`惂[h̕A
	//Gg[̕`
	}else if(  m_nCurrentTool==ID_TOOL_ENTRY_BL
			|| m_nCurrentTool==ID_TOOL_ENTRY_BR
			|| m_nCurrentTool==ID_TOOL_ENTRY_WL
			|| m_nCurrentTool==ID_TOOL_ENTRY_WR){
		CBSchEntry entry;
		entry.SetPoint(&m_pointOccasional);
		int nType;
		switch(m_nCurrentTool){
		case ID_TOOL_ENTRY_BL:nType=ENTRY_BL;break;
		case ID_TOOL_ENTRY_BR:nType=ENTRY_BR;break;
		case ID_TOOL_ENTRY_WL:nType=ENTRY_WL;break;
		case ID_TOOL_ENTRY_WR:nType=ENTRY_WR;break;
		}
		entry.SetType(nType);
		entry.Draw(pDC,DRAW_XOR,m_nVExt,m_nWExt);
	//ڍ_̕`
	}else if(m_nCurrentTool==ID_TOOL_JUNCTION){
		CBSchJunc junction;
		junction.SetPoint(&m_pointOccasional);
		junction.Draw(pDC,DRAW_XOR,m_nVExt,m_nWExt);
	}
	m_bDrawOccasional=bDraw;
}
